package plaGen;

import java.util.Vector;

public class AndPlane {

	private Vector andPull;
	private Vector orPlane;
	private Vector inInv;
	private Vector gnd;
	
	//	private Vector nodes;
	//private Vector arcs;
	
	private String nodeString;
	private String arcString;
	
	private Paramgetter params;
	private Caseinfo info;
	
	private int numNets;
	private int netCount;

	private int numContacts;
	private int contactCount;
	
	private int numPins;
	private int pinCount;
	
	private int numNmos;
	private int nmosCount;
	
	private int numPWells;
	private int pwellCount;
	
	public AndPlane(Vector andPullAndPlane, Vector orPlaneAndPlane, Vector inInvAndPlane, Vector gndAndPlane,
			Paramgetter p, Caseinfo i, int nets, int contacts, int pins, int nmos, int pwells) {
		//nodes = new Vector(100,100);
		//arcs = new Vector(100,100);
		
		nodeString = "";
		arcString = "";
		
		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPins = pins;
		pinCount = 0;
		numNmos = nmos;
		nmosCount = 0;
		numPWells = pwells;
		pwellCount = 0;
		
		andPull = andPullAndPlane;
		orPlane = orPlaneAndPlane;
		inInv = inInvAndPlane;
		gnd = gndAndPlane;
		params = p;
		info = i;
		makeCells();
	}

	private void makeCells() {
		int[][] andPlane = info.getInputMatrix();
		
		int numCases = info.getNumCases();
		int numRows = (int)Math.ceil(.5 * numCases);
		int numCols = info.getNumInputBits();
		
		AndPlaneCell[][] cells= new AndPlaneCell[numRows][numCols];
		AndPlaneCell cell = null;
		LayNode upperLeftIn = null;
		LayNode midLeftIn = null;
		LayNode lowerLeftIn = null;
		LayNode leftBottomIn = null;
		LayNode rightBottomIn = null;
		for(int row = 0 ; row < numRows ; row++){
			//System.out.println();
			for(int col = 0 ; col < numCols ; col++ ){
				if(row > 0){ // NOT zeroth row
					//System.out.println("tester1");
					leftBottomIn = cells[row-1][col].getleftHiOut();
					rightBottomIn = cells[row-1][col].getrightHiOut();
				}
				else {  // zeroth row
					//System.out.println("tester2");
					leftBottomIn = (LayNode) inInv.get(2*col);
					rightBottomIn = (LayNode) inInv.get((2 * col)+1);
				}
				
				// bulk: NOT zeroth column, not top row unless even # cases
				if((col > 0) && ((isEven(numCases))||(row<numRows-1))){
					//System.out.println("tester3");
					upperLeftIn = cells[row][col - 1].getUpperRightOut();
					midLeftIn = cells[row][col - 1].getMidRightOut();
					lowerLeftIn = cells[row][col - 1].getLowerRightOut();
				}
				// zeroth column, not top row unless even # cases
				else if ((col == 0) && ((isEven(numCases))||(row<numRows-1))){
					//System.out.println("tester4");
					upperLeftIn = (LayNode) andPull.get((3 * row)+2);
					midLeftIn = (LayNode) andPull.get((3 * row)+1);
					lowerLeftIn = (LayNode) andPull.get(3 * row);
				}
				// top row, NOT zeroth column, odd # of cases
				else if (col != 0){ 
					//System.out.println("tester5");
					midLeftIn = cells[row][col - 1].getMidRightOut();
					lowerLeftIn = cells[row][col - 1].getLowerRightOut();
				}
				// zeroth column, odd # of cases
				else{
					//System.out.println("tester6");
					midLeftIn = (LayNode) andPull.get((3 * row)+1);
					lowerLeftIn = (LayNode) andPull.get(3 * row);
				}
				
				if(col < numCols -1){// no need for next cell connection
					//System.out.println("tester7");
					if((isEven(numCases))||(row<(numRows-1))){//standard cell
						//System.out.println("tester8");
						cell = new AndPlaneCell(upperLeftIn,midLeftIn,lowerLeftIn,leftBottomIn,
								rightBottomIn,params,andPlane[2*row][col],andPlane[(2*row)+1][col],row,col,
								numNets,numContacts,numPins,numNmos,numPWells);
					}
					else{// cell on top-row, with only bottom half
						//System.out.println("tester9");
						cell = new AndPlaneCell(midLeftIn,lowerLeftIn,leftBottomIn,
								rightBottomIn,params,andPlane[2*row][col],row,col,numNets,numContacts,
								numPins,numNmos,numPWells);
					}
				}
				else{//Cell constructor needs the ground connection
					//System.out.println("tester10");
					if((isEven(numCases))||(row<(numRows-1))){//standard end-column cell
						//System.out.println("tester11");
						cell = new AndPlaneCell(upperLeftIn,midLeftIn,lowerLeftIn,leftBottomIn,
								rightBottomIn,params,andPlane[2*row][col],andPlane[2*row+1][col],
								(LayNode)orPlane.get(2*row),(LayNode)gnd.get(row),
								(LayNode)orPlane.get((2 * row)+1),row,col,numNets,numContacts,
								numPins,numNmos,numPWells);
					}
					else{// cell on top-row, end-column, with only bottom half
						//System.out.println("tester12");
						cell = new AndPlaneCell(midLeftIn,lowerLeftIn,leftBottomIn,rightBottomIn,
								params,andPlane[2*row][col],(LayNode)orPlane.get(2*row),
								(LayNode)gnd.get(row),row,col,numNets,numContacts,
								numPins,numNmos,numPWells);
					}
				}
				cells[row][col] = cell;
				//addArcs(cell.getArcs());
				//addNodes(cell.getNodes());
				nodeString += cell.getNodeString();
				arcString += cell.getArcString();
				
				
				numNets += cell.getNumNets();
				
				numContacts += cell.getNumContacts();

				numPins += cell.getNumPins();
			
				numNmos += cell.getNumNmos();
			
				numPWells += cell.getNumPWells();
				
				netCount += cell.getNumNets();
				
				contactCount += cell.getNumContacts();

				pinCount += cell.getNumPins();
			
				nmosCount += cell.getNumNmos();
			
				pwellCount += cell.getNumPWells();
			}
		}
	}

	private boolean isEven(int n) {
		return (n%2==0);
	}
/*
	private void addArcs(Vector vA) {
		int numAdds = vA.size();
		for(int n = 0; n<numAdds; n++){
			arcs.add(vA.get(n));
		}
	}

	private void addNodes(Vector vN) {
		int numAdds = vN.size();
		for(int n = 0; n<numAdds; n++){
			nodes.add(vN.get(n));
		}
	}
	
	public Vector getNodes() {
		return nodes;
	}

	public Vector getArcs() {
		return arcs;
	}
*/
	public int getNumNets() {
		return netCount;
	}

	public int getNumContacts() {
		return contactCount;
	}

	public int getNumPins() {
		return pinCount;
	}

	public int getNumNmos() {
		return nmosCount;
	}

	public int getNumPWells() {
		return pwellCount;
	}

	public String getNodeString() {
		return nodeString;
	}

	public String getArcString() {
		return arcString;
	}

}
