package plaGen;

public class AndPlaneCell {

	// private Vector nodes;
	// private Vector arcs;

	private String nodeString;

	private String arcString;

	private int numNets;

	private int netCount;

	private int numContacts;

	private int contactCount;

	private int numPins;

	private int pinCount;

	private int numNmos;

	private int nmosCount;

	private int numPWells;

	private int pwellCount;

	private LayNode loLIn;

	private LayNode midLIn;

	private LayNode hiLIn;

	private LayNode lBottomIn;

	private LayNode rBottomIn;

	private LayNode loROut;

	private LayNode midROut;

	private LayNode hiROut;

	private LayNode topLOut;

	private LayNode topROut;

	private LayNode midM;

	private LayNode endHi;

	private LayNode endMid;

	private LayNode endLo;

	private LayNode poly1;

	private LayNode poly2;

	private int col;

	private Paramgetter params;

	private int loBit;

	private int hiBit;

	public AndPlaneCell(LayNode upperLeftIn, LayNode midLeftIn,
			LayNode lowerLeftIn, LayNode leftBottomIn, LayNode rightBottomIn,
			Paramgetter p, int i, int j, int m, int n, int nets, int contacts,
			int pins, int nmos, int pwells) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPins = pins;
		pinCount = 0;
		numNmos = nmos;
		nmosCount = 0;
		numPWells = pwells;
		pwellCount = 0;

		loROut = null;
		midROut = null;
		hiROut = null;
		topLOut = null;
		topROut = null;

		midM = null;
		poly1 = null;
		poly2 = null;

		loLIn = lowerLeftIn;
		midLIn = midLeftIn;
		hiLIn = upperLeftIn;
		lBottomIn = leftBottomIn;
		rBottomIn = rightBottomIn;

		col = n;

		params = p;

		loBit = i;
		hiBit = j;

		if (col == 0) {
			connectLoHalfToLeft();
			connectHiHalfToLeft();
		}
		makeLoSection();
		makeHiSection();
	}

	public AndPlaneCell(LayNode midLeftIn, LayNode lowerLeftIn,
			LayNode leftBottomIn, LayNode rightBottomIn, Paramgetter p, int i,
			int m, int n, int nets, int contacts, int pins, int nmos, int pwells) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPins = pins;
		pinCount = 0;
		numNmos = nmos;
		nmosCount = 0;
		numPWells = pwells;
		pwellCount = 0;

		loROut = null;
		midROut = null;
		hiROut = null;
		topLOut = null;
		topROut = null;

		midM = null;
		poly1 = null;
		poly2 = null;

		loLIn = lowerLeftIn;
		midLIn = midLeftIn;
		lBottomIn = leftBottomIn;
		rBottomIn = rightBottomIn;

		col = n;

		params = p;

		loBit = i;
		if (col == 0) {
			connectLoHalfToLeft();
		}
		makeLoSection();
	}

	public AndPlaneCell(LayNode upperLeftIn, LayNode midLeftIn,
			LayNode lowerLeftIn, LayNode leftBottomIn, LayNode rightBottomIn,
			Paramgetter p, int i, int j, LayNode node, LayNode node2,
			LayNode node3, int m, int n, int nets, int contacts, int pins,
			int nmos, int pwells) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPins = pins;
		pinCount = 0;
		numNmos = nmos;
		nmosCount = 0;
		numPWells = pwells;
		pwellCount = 0;

		loROut = null;
		midROut = null;
		hiROut = null;
		topLOut = null;
		topROut = null;

		loLIn = lowerLeftIn;
		midLIn = midLeftIn;
		hiLIn = upperLeftIn;
		lBottomIn = leftBottomIn;
		rBottomIn = rightBottomIn;

		midM = null;
		poly1 = null;
		poly2 = null;

		endLo = node;
		endMid = node2;
		endHi = node3;

		col = n;

		params = p;

		loBit = i;
		hiBit = j;

		makeLoSection();
		makeHiSection();
		connectLoOut();
		connectHiOut();
	}

	public AndPlaneCell(LayNode midLeftIn, LayNode lowerLeftIn,
			LayNode leftBottomIn, LayNode rightBottomIn, Paramgetter p, int i,
			LayNode node, LayNode node2, int m, int n, int nets, int contacts,
			int pins, int nmos, int pwells) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPins = pins;
		pinCount = 0;
		numNmos = nmos;
		nmosCount = 0;
		numPWells = pwells;
		pwellCount = 0;

		loROut = null;
		midROut = null;
		hiROut = null;
		topLOut = null;
		topROut = null;

		loLIn = lowerLeftIn;
		midLIn = midLeftIn;
		lBottomIn = leftBottomIn;
		rBottomIn = rightBottomIn;

		midM = null;
		poly1 = null;
		poly2 = null;

		endLo = node;
		endMid = node2;

		col = n;

		params = p;

		loBit = i;

		makeLoSection();
		connectLoOut();
	}

	private void connectHiHalfToLeft() {
		LayNode hiL = makeHiLM1Pin();
		makeArc(hiLIn, hiL, "Metal-1");
		hiLIn = hiL;
	}

	private LayNode makeHiLM1Pin() {
		String type = "Metal-1-Pin";
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = lBottomIn.getX()
				- (params.getTransistorToActiveConnection()
						+ (.5 * params.getM1Width()) + (.5 * params
						.getPolyWidth()));
		double y = hiLIn.getY();
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// addNodes(cell.getNodes());
		nodeString += node.getText();
		return node;
	}

	private void connectLoHalfToLeft() {
		LayNode loL = makeLoLM1Pin();
		LayNode midL = makeMidLPWell();
		makeArc(loLIn, loL, "Metal-1");
		makeArc(midLIn, midL, "Metal-1");
		loLIn = loL;
		midLIn = midL;
	}

	private LayNode makeMidLPWell() {
		String type = "Metal-1-P-Well-Con";
		String name = "well@" + String.valueOf(numPWells);
		pwellCount++;
		numPWells++;
		double x = lBottomIn.getX()
				- (params.getTransistorToActiveConnection()
						+ (.5 * params.getM1Width()) + (.5 * params
						.getPolyWidth()));
		double y = midLIn.getY();
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeLoLM1Pin() {
		String type = "Metal-1-Pin";
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		// //System.out.println("pin@"+ String.valueOf(numPins));
		double x = lBottomIn.getX()
				- (params.getTransistorToActiveConnection()
						+ (.5 * params.getM1Width()) + (.5 * params
						.getPolyWidth()));
		double y = loLIn.getY();
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private void connectHiOut() {
		makeArc(hiROut, endHi, "Metal-1");
	}

	private void connectLoOut() {
		makeArc(loROut, endLo, "Metal-1");
		makeArc(midROut, endMid, "Metal-1");
	}

	private void makeHiSection() {
		String m1 = "Metal-1";
		String poly = "Polysilicon-1";
		String diff = "N-Active";

		LayNode actPin = null;

		if (hiBit == 1) {
			hiROut = makeHiRAct();
			topROut = makeHiRTrans();
			actPin = makeHiActPin();
			topLOut = makeTopLPolyPin();
			makeArc(actPin, topROut, diff);
			makeArc(actPin, midM, diff);
			makeArc(hiROut, topROut, diff);
		} else if (hiBit == 0) {
			hiROut = makeHiRM1Pin();
			topLOut = makeHiLTrans();
			actPin = makeHiActPin();
			topROut = makeTopRPolyPin();

			makeArc(actPin, topLOut, diff);
			makeArc(actPin, midM, diff);

			String inNodeType = hiLIn.getType();
			if (inNodeType.equals("Metal-1-N-Active-Con")) {
				makeArc(hiLIn, topLOut, diff);
			} else {
				LayNode hiLAct = makeHiLAct();
				makeArc(hiLAct, topLOut, diff);
				makeArc(hiLAct, hiLIn, m1);
			}
		} else {
			topLOut = makeTopLPolyPin();
			topROut = makeTopRPolyPin();
			hiROut = makeHiRM1Pin();
		}
		makeArc(hiLIn, hiROut, m1);
		makeArc(poly1, topLOut, poly);
		makeArc(poly2, topROut, poly);
	}

	private LayNode makeHiLAct() {
		String type = "Metal-1-N-Active-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = lBottomIn.getX()
				- (params.getTransistorToActiveConnection()
						+ (.5 * params.getM1Width()) + (.5 * params
						.getPolyWidth()));
		double y = hiLIn.getY();
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeTopRPolyPin() {
		String type = "Polysilicon-1-Pin";
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		// //System.out.println("pin@"+ String.valueOf(numPins));
		double x = rBottomIn.getX();
		double y = hiLIn.getY();
		double width = params.getPolyWidth();
		double height = width;
		String orientation = "";
		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeHiLTrans() {
		String type = "N-Transistor";
		String name = "nmos@" + String.valueOf(numNmos);
		nmosCount++;
		numNmos++;
		double x = lBottomIn.getX();
		double y = hiLIn.getY();
		double width = params.getM1Width();
		double height = params.getPolyWidth();
		String orientation = "R";
		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeHiRM1Pin() {
		String type = "Metal-1-Pin";
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = rBottomIn.getX()
				+ (params.getTransistorToActiveConnection()
						+ (.5 * params.getM1Width()) + (.5 * params
						.getPolyWidth()));
		double y = hiLIn.getY();
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeTopLPolyPin() {
		String type = "Polysilicon-1-Pin";
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		// //System.out.println("pin@"+ String.valueOf(numPins));
		double x = lBottomIn.getX();
		double y = hiLIn.getY();
		double width = params.getPolyWidth();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeHiActPin() {
		String type = "N-Active-Pin";
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		// //System.out.println("pin@"+ String.valueOf(numPins));
		double x = lBottomIn.getX()
				+ (params.getTransistorToActiveConnection()
						+ (.5 * params.getM1Width()) + (.5 * params
						.getPolyWidth()));
		double y = hiLIn.getY();
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeHiRTrans() {
		String type = "N-Transistor";
		String name = "nmos@" + String.valueOf(numNmos);
		nmosCount++;
		numNmos++;
		double x = rBottomIn.getX();
		double y = hiLIn.getY();
		double width = params.getM1Width();
		double height = params.getPolyWidth();
		String orientation = "R";
		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeHiRAct() {
		String type = "Metal-1-N-Active-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = rBottomIn.getX()
				+ (params.getTransistorToActiveConnection()
						+ (.5 * params.getM1Width()) + (.5 * params
						.getPolyWidth()));
		double y = hiLIn.getY();
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private void makeLoSection() {
		String m1 = "Metal-1";
		String poly = "Polysilicon-1";
		String diff = "N-Active";

		midM = makeMidM();
		midROut = makeMidROut();

		makeArc(midLIn, midM, m1);
		makeArc(midM, midROut, m1);

		LayNode actPin = null;

		if (loBit == 1) {
			loROut = makeLoRAct();
			poly2 = makeLoRTrans();
			actPin = makeLoActPin();
			poly1 = makeBottomLPolyPin();
			makeArc(actPin, poly2, diff);
			makeArc(actPin, midM, diff);
			makeArc(loROut, poly2, diff);
		} else if (loBit == 0) {
			loROut = makeLoRM1Pin();
			poly1 = makeLoLTrans();
			actPin = makeLoActPin();
			poly2 = makeBottomRPolyPin();

			makeArc(actPin, poly1, diff);
			makeArc(actPin, midM, diff);

			String inNodeType = loLIn.getType();
			if (inNodeType.equals("Metal-1-N-Active-Con")) {
				makeArc(loLIn, poly1, diff);
			} else {
				LayNode loLAct = makeLoLAct();
				makeArc(loLAct, poly1, diff);
				makeArc(loLAct, loLIn, m1);
			}
		} else {
			poly1 = makeBottomLPolyPin();
			poly2 = makeBottomRPolyPin();
			loROut = makeLoRM1Pin();
		}
		makeArc(loLIn, loROut, m1);
		makeArc(lBottomIn, poly1, poly);
		makeArc(rBottomIn, poly2, poly);

	}

	private LayNode makeLoLAct() {
		String type = "Metal-1-N-Active-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = lBottomIn.getX()
				- (params.getTransistorToActiveConnection()
						+ (.5 * params.getM1Width()) + (.5 * params
						.getPolyWidth()));
		double y = loLIn.getY();
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeLoLTrans() {
		String type = "N-Transistor";
		String name = "nmos@" + String.valueOf(numNmos);
		nmosCount++;
		numNmos++;
		double x = lBottomIn.getX();
		double y = loLIn.getY();
		double width = params.getM1Width();
		double height = params.getPolyWidth();
		String orientation = "R";
		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeLoRM1Pin() {
		String type = "Metal-1-Pin";
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		// //System.out.println("pin@"+ String.valueOf(numPins));
		double x = rBottomIn.getX()
				+ (params.getTransistorToActiveConnection()
						+ (.5 * params.getM1Width()) + (.5 * params
						.getPolyWidth()));
		double y = loLIn.getY();
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeBottomRPolyPin() {
		String type = "Polysilicon-1-Pin";
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		// //System.out.println("pin@"+ String.valueOf(numPins));
		double x = rBottomIn.getX();
		double y = loLIn.getY();
		double width = params.getPolyWidth();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeBottomLPolyPin() {
		String type = "Polysilicon-1-Pin";
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		// //System.out.println("pin@"+ String.valueOf(numPins));
		double x = lBottomIn.getX();
		double y = loLIn.getY();
		double width = params.getPolyWidth();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeLoActPin() {
		String type = "N-Active-Pin";
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		// System.out.println("pin@"+ String.valueOf(numPins));
		double x = lBottomIn.getX()
				+ (params.getTransistorToActiveConnection()
						+ (.5 * params.getM1Width()) + (.5 * params
						.getPolyWidth()));
		double y = loLIn.getY();
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeLoRTrans() {
		String type = "N-Transistor";
		String name = "nmos@" + String.valueOf(numNmos);
		nmosCount++;
		numNmos++;
		double x = rBottomIn.getX();
		double y = loLIn.getY();
		double width = params.getM1Width();
		double height = params.getPolyWidth();
		String orientation = "R";
		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeLoRAct() {
		String type = "Metal-1-N-Active-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = rBottomIn.getX()
				+ (params.getTransistorToActiveConnection()
						+ (.5 * params.getM1Width()) + (.5 * params
						.getPolyWidth()));
		double y = loLIn.getY();
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeMidM() {
		String type = "Metal-1-N-Active-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = lBottomIn.getX()
				+ (params.getTransistorToActiveConnection()
						+ (.5 * params.getM1Width()) + (.5 * params
						.getPolyWidth()));
		double y = midLIn.getY();
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeMidROut() {
		String type = "Metal-1-P-Well-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = rBottomIn.getX()
				+ (params.getTransistorToActiveConnection()
						+ (.5 * params.getM1Width()) + (.5 * params
						.getPolyWidth()));
		double y = midLIn.getY();
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private void makeArc(LayNode startNode, LayNode endNode, String arcType) {
		String type = arcType;
		String name = "net@" + String.valueOf(numNets);
		netCount++;
		numNets++;
		String nameTD = "";
		double width = params.getM1Width();
		if (type.equals("Polysilicon-1")) {
			width = params.getPolyWidth();
		} else if (type.equals("N-Active") || type.equals("P-Active")) {
			width = params.getActiveWidth();
		}
		String flags = "S";

		LayArc arc = new LayArc(type, name, nameTD, width, flags, startNode,
				endNode, params);
		// nodes.add(node);
		arcString += arc.getText();
	}

	public LayNode getleftHiOut() {
		return topLOut;
	}

	public LayNode getrightHiOut() {
		return topROut;
	}

	public LayNode getUpperRightOut() {
		return hiROut;
	}

	public LayNode getMidRightOut() {
		return midROut;
	}

	public LayNode getLowerRightOut() {
		return loROut;
	}

	/*
	 * public Vector getArcs() { return arcs; } public Vector getNodes() {
	 * return nodes; }
	 */

	public int getNumNets() {
		return netCount;
	}

	public int getNumContacts() {
		return contactCount;
	}

	public int getNumPins() {
		return pinCount;
	}

	public int getNumNmos() {
		return nmosCount;
	}

	public int getNumPWells() {
		return pwellCount;
	}

	public String getNodeString() {
		return nodeString;
	}

	public String getArcString() {
		return arcString;
	}
}
