package plaGen;

import java.util.Vector;

public class AndPull {

	private Vector pwr;
	private Vector andPlane;
	
	//private Vector nodes;
	//private Vector arcs;
	
	private String nodeString;
	private String arcString;
	
	private Paramgetter params;
	
	private int numNets;
	private int netCount;

	private int numContacts;
	private int contactCount;
	
	private int numPins;
	private int pinCount;
	
	private int numPmos;
	private int pmosCount;
	
	private int numNWells;
	private int nwellCount;
	
	public AndPull(Vector andPullPwr, Vector andPullAndPlane, Paramgetter p, int nets, int contacts, 
			int pins, int pmos, int nwells) {
		//nodes = new Vector(10,10);
		//arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";
		
		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPins = pins;
		pinCount = 0;
		numPmos = pmos;
		pmosCount = 0;
		numNWells = nwells;
		nwellCount = 0;
		
		pwr = andPullPwr;
		andPlane = andPullAndPlane;
		params = p;
		makeCells();
	}

	private void makeCells() {
		int numCells = (int)Math.ceil(.5 * pwr.size());
		LayNode pwr1 = null;
		LayNode pwr2 = null;
		LayNode and1 = null;
		LayNode and2 = null;
		LayNode and3 = null;
		AndPullCell cell = null;
		LayNode link = null;
		
		for(int n = 0 ; n < numCells ; n++){
			pwr1 = (LayNode) pwr.get(2 * n);
			and1 = (LayNode) andPlane.get(3 * n);
			and2 = (LayNode) andPlane.get((3 * n)+1);
			
			if (n<(numCells-1)||isEven(pwr.size())){
				and3 = (LayNode) andPlane.get((3 * n)+2);
				pwr2 = (LayNode) pwr.get((2 * n)+1);
				if (n>0){
					cell = new AndPullCell(pwr1,pwr2,and1,and2,and3,params,n,link,numNets,
							numContacts,numPins,numPmos,numNWells);
				}
				else {
					cell = new AndPullCell(pwr1,pwr2,and1,and2,and3,params,n,numNets,
							numContacts,numPins,numPmos,numNWells);
				}
				link = cell.getPrevLink();
			}
			else{
				cell = new AndPullCell(pwr1,and1,and2,params,n,link,numNets,
						numContacts,numPins,numPmos,numNWells);
			}
			//addArcs(cell.getArcs());
			//addNodes(cell.getNodes());
			nodeString += cell.getNodeString();
			arcString += cell.getArcString();
			
			numNets += cell.getNumNets();
			
			numContacts += cell.getNumContacts();
		
			numPmos += cell.getNumPmos();
			
			netCount += cell.getNumNets();
			
			contactCount += cell.getNumContacts();
		
			pmosCount += cell.getNumPmos();
			
		}
	}

	private boolean isEven(int n) {
		return (n%2==0);
	}
/*
	private void addArcs(Vector vA) {
		int numAdds = vA.size();
		for(int n = 0; n<numAdds; n++){
			arcs.add(vA.get(n));
		}
	}

	private void addNodes(Vector vN) {
		int numAdds = vN.size();
		for(int n = 0; n<numAdds; n++){
			nodes.add(vN.get(n));
		}
	}
	
	public Vector getNodes() {
		return nodes;
	}

	public Vector getArcs() {
		return arcs;
	}
*/

	public int getNumNets() {
		return netCount;
	}

	public int getNumContacts() {
		return contactCount;
	}

	public int getNumPins() {
		return pinCount;
	}

	public int getNumPmos() {
		return pmosCount;
	}

	public int getNumNWells() {
		return nwellCount;
	}

	public String getNodeString() {
		return nodeString;
	}

	public String getArcString() {
		return arcString;
	}

}
