package plaGen;

public class AndPullCell {

	// private Vector nodes;
	// private Vector arcs;

	private String nodeString;

	private String arcString;

	private LayNode and1;

	private LayNode and2;

	private LayNode pwr1;

	private LayNode linkPrev;

	private LayNode linkNext;

	private int numNets;

	private int netCount;

	private int numContacts;

	private int contactCount;

	private int numPmos;

	private int pmosCount;

	private Paramgetter params;

	private LayNode via;

	private LayNode and3;

	private LayNode pwr2;

	public AndPullCell(LayNode p1, LayNode p2, LayNode a1, LayNode a2,
			LayNode a3, Paramgetter p, int n, int nets, int contacts, int pins,
			int pmos, int nwells) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPmos = pmos;
		pmosCount = 0;

		and1 = a1;
		and2 = a2;
		and3 = a3;
		pwr1 = p1;
		pwr2 = p2;
		via = null;
		linkNext = null;
		params = p;
		makeHalf1a();
		makehalf2();
	}

	public AndPullCell(LayNode p1, LayNode p2, LayNode a1, LayNode a2,
			LayNode a3, Paramgetter p, int n, LayNode prev, int nets,
			int contacts, int pins, int pmos, int nwells) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPmos = pmos;
		pmosCount = 0;

		and1 = a1;
		and2 = a2;
		and3 = a3;
		pwr1 = p1;
		pwr2 = p2;
		linkNext = null;
		linkPrev = prev;
		via = null;
		params = p;
		makeHalf1();
		makehalf2();
	}

	public AndPullCell(LayNode p1, LayNode a1, LayNode a2, Paramgetter p,
			int n, LayNode prev, int nets, int contacts, int pins, int pmos,
			int nwells) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;

		numPmos = pmos;
		pmosCount = 0;

		and1 = a1;
		and2 = a2;
		pwr1 = p1;
		linkPrev = prev;
		params = p;
		via = null;
		makeHalf1();
	}

	private void makehalf2() {
		String m1 = "Metal-1";
		String poly = "Polysilicon-1";
		String pAct = "P-Active";

		LayNode actConL = makeActConL(pwr2);
		linkNext = makeWeakPmos(actConL);
		LayNode actConR = makeActConR(linkNext);

		makeArc(pwr2, actConL, m1);
		makeArc(actConL, linkNext, pAct);
		makeArc(linkNext, actConR, pAct);
		makeArc(actConR, and3, m1);
		makeArc(via, linkNext, poly);
	}

	private void makeHalf1() {
		String m1 = "Metal-1";
		String poly = "Polysilicon-1";
		String pAct = "P-Active";

		LayNode actConL = makeActConL(pwr1);
		LayNode pmos = makeWeakPmos(actConL);
		LayNode actConR = makeActConR(pmos);
		via = makeVia(pmos);

		makeArc(pwr1, actConL, m1);
		makeArc(actConL, pmos, pAct);
		makeArc(pmos, actConR, pAct);
		makeArc(actConR, and1, m1);
		makeArc(pmos, via, poly);
		makeArc(via, and2, m1);
		makeArc(linkPrev, pmos, poly);
	}

	private void makeHalf1a() {
		String m1 = "Metal-1";
		String poly = "Polysilicon-1";
		String pAct = "P-Active";

		LayNode actConL = makeActConL(pwr1);
		LayNode pmos = makeWeakPmos(actConL);
		LayNode actConR = makeActConR(pmos);
		via = makeVia(pmos);

		makeArc(pwr1, actConL, m1);
		makeArc(actConL, pmos, pAct);
		makeArc(pmos, actConR, pAct);
		makeArc(actConR, and1, m1);
		makeArc(pmos, via, poly);
		makeArc(via, and2, m1);

	}

	private void makeArc(LayNode head, LayNode tail, String aT) {
		String type = aT;
		String name = "net@" + String.valueOf(numNets);
		netCount++;
		numNets++;
		String nameTD = "";
		double width = params.getM1Width();
		if (type.equals("Polysilicon-1")) {
			width = params.getWeakPolyWidth();
		} else if (type.equals("N-Active") || type.equals("P-Active")) {
			width = params.getWeakActiveWidth();
		}
		String flags = "S";

		LayArc arc = new LayArc(type, name, nameTD, width, flags, head, tail,
				params);
		// arcs.add(arc);
		arcString += arc.getText();
	}

	private LayNode makeVia(LayNode pmos) {
		String type = "Metal-1-Polysilicon-1-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = pmos.getX();
		double y = pmos.getY() + params.getM1ToM1() + params.getM1Width();
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeActConR(LayNode pmos) {
		String type = "Metal-1-P-Active-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double width = params.getM1Width();
		double height = width;
		double x = pmos.getX() + (.5 * params.getM1Width())
				+ (.5 * params.getWeakPolyWidth())
				+ params.getWeakTransistorToActiveConnection();
		double y = pmos.getY();
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private LayNode makeWeakPmos(LayNode con) {
		String type = "P-Transistor";
		String name = "pmos@" + String.valueOf(numPmos);
		pmosCount++;
		numPmos++;
		double width = params.getWeakPmosSize();
		double height = params.getWeakPolyWidth();
		double x = con.getX()
				+ ((.5 * params.getM1Width())
						+ (.5 * params.getWeakPolyWidth()) + params
						.getWeakTransistorToActiveConnection());
		double y = con.getY();
		String orientation = "R";
		String flags = "V";
		String vars = "SIM_weak_node(D5G1;)SWeak";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, flags, vars);
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private LayNode makeActConL(LayNode pwr) {
		String type = "Metal-1-P-Active-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double width = params.getM1Width();
		double height = width;
		double x = pwr.getX() + 4
				+ (params.getM1Width());
		double y = pwr.getY();
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	public LayNode getPrevLink() {
		return linkNext;
	}

	/*
	 * public Vector getArcs() { return arcs; } public Vector getNodes() {
	 * return nodes; }
	 */
	public int getNumNets() {
		return netCount;
	}

	public int getNumContacts() {
		return contactCount;
	}

	public int getNumPmos() {
		return pmosCount;
	}

	public String getNodeString() {
		return nodeString;
	}

	public String getArcString() {
		return arcString;
	}
}
