package plaGen;

import java.util.Vector;

public class Gnd {

	private Vector inInv;

	private Vector andPlane;

	private Vector orPlane;

	private LayNode exp;

	// private Vector nodes;
	// private Vector arcs;

	private String nodeString;

	private String arcString;

	private Paramgetter params;

	private LayNode midLowVia;

	private int numNets;

	private int netCount;

	private int numPins;

	private int pinCount;

	private int numPWells;

	private int pwellCount;

	private int numContacts;

	private int contactCount;

	public Gnd(Vector inInvGnd, Vector gndAndPlane, Vector orPlaneGnd,
			LayNode gndGndExp, Paramgetter parameters, int nets, int pins,
			int pwells, int contacts) {

		inInv = inInvGnd;
		andPlane = gndAndPlane;
		orPlane = orPlaneGnd;
		exp = gndGndExp;
		params = parameters;
		midLowVia = null;

		nodeString = "";
		arcString = "";

		// nodes = new Vector(100,100);
		// arcs = new Vector(100,100);

		numNets = nets;
		netCount = 0;
		numPins = pins;
		pinCount = 0;
		numPWells = pwells;
		pwellCount = 0;
		numContacts = contacts;
		contactCount = 0;

		makeMidLowVia();

		makeLowLeg();
		makeMidLeg();
		makeHiLeg();
	}

	private void makeHiLeg() {
		int numSegments = orPlane.size();
		for (int n = 0; n < numSegments; n++) {
			LayNode startNode = null;
			LayNode endNode = (LayNode) orPlane.get(n);
			if (n > 0) {
				startNode = (LayNode) orPlane.get(n - 1);
			} else {
				startNode = exp;
			}
			HiGndLegCell cell = new HiGndLegCell(startNode, endNode, params, n,
					numNets, numPins, numPWells);
			// addArcs(cell.getArcs());
			arcString += cell.getArcString();

			numNets += cell.getNumNets();

			netCount += cell.getNumNets();
		}
	}

	private void makeMidLeg() {
		int numSegments = andPlane.size() + 1;
		for (int n = 0; n < numSegments; n++) {
			LayNode startNode = null;
			LayNode endNode = null;
			if (n > 0 && n < numSegments - 1) {
				startNode = (LayNode) andPlane.get(n - 1);
				endNode = (LayNode) andPlane.get(n);
			} else if (n == 0) {
				startNode = midLowVia;
				endNode = (LayNode) andPlane.get(n);
			} else {
				startNode = (LayNode) andPlane.get(n - 1);
				endNode = exp;
			}
			MidGndLegCell cell = new MidGndLegCell(startNode, endNode, params,
					n, numNets, numPins, numPWells);
			// addArcs(cell.getArcs());
			nodeString += cell.getNodeString();
			arcString += cell.getArcString();

			numNets += cell.getNumNets();

			netCount += cell.getNumNets();
		}
	}

	private void makeLowLeg() {
		int numSegments = inInv.size();
		for (int n = 0; n < numSegments; n++) {
			LayNode startNode = (LayNode) inInv.get(n);
			LayNode endNode = null;
			if (n < numSegments - 1) {
				endNode = (LayNode) inInv.get(n + 1);
			} else {
				endNode = midLowVia;
			}
			LowGndLegCell cell = new LowGndLegCell(startNode, endNode, params,
					n, numNets, numPins, numPWells);
			// addArcs(cell.getArcs());
			// addNodes(cell.getNodes());
			nodeString += cell.getNodeString();
			arcString += cell.getArcString();

			numNets += cell.getNumNets();

			numPWells += cell.getNumPWells();

			netCount += cell.getNumNets();

			pwellCount += cell.getNumPWells();

		}
	}

	private void makeMidLowVia() {
		String type = "Metal-1-Metal-2-Con";
		double mW = params.getPowerAndGndWide();
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		// System.out.println("pin@"+ String.valueOf(numPins));
		double xVal = exp.getX();
		double yVal = ((LayNode) inInv.get(0)).getY();
		String flags = "V";
		midLowVia = new LayNode(type, name, "", xVal, yVal, mW, mW, "", flags);
		nodeString += midLowVia.getText();
		// nodes.add(midLowVia);
	}

	/*
	 * public Vector getNodes() { return nodes; } public Vector getArcs() {
	 * return arcs; } private void addArcs(Vector aV) { int numadds = aV.size();
	 * for(int n = 0; n<num//adds; n++){ arcs.add(aV.get(n)); } } private void
	 * addNodes(Vector nV) { int numadds = nV.size(); for(int n = 0; n<num//adds;
	 * n++){ nodes.add(nV.get(n)); } }
	 */
	public int getNumNets() {
		return netCount;
	}

	public int getNumPins() {
		return pinCount;
	}

	public int getNumPWells() {
		return pwellCount;
	}

	public int getNumContacts() {
		return contactCount;
	}

	public String getNodeString() {
		return nodeString;
	}

	public String getArcString() {
		return arcString;
	}

}
