package plaGen;

import java.util.Vector;

public class InInv {

	private Vector pwrNodes;

	private Vector gndNodes;

	private Vector expNodes;

	private Vector andNodes;

	// private Vector layNodes;
	// private Vector layArcs;
	private String nodeString;

	private String arcString;

	private Paramgetter params;

	private int numCells;

	private int numNets;

	private int netCount;

	private int numContacts;

	private int contactCount;

	private int numPins;

	private int pinCount;

	private int numNmos;

	private int nmosCount;

	private int numPmos;

	private int pmosCount;

	public InInv(Vector inInvPwr, Vector inInvGnd, Vector inInvInExp,
			Vector inInvAndPlane, Paramgetter p, int nets, int contacts,
			int pins, int pmos, int nmos) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPins = pins;
		pinCount = 0;
		numNmos = nmos;
		nmosCount = 0;
		numPmos = pmos;
		pmosCount = 0;

		params = p;
		pwrNodes = inInvPwr;
		gndNodes = inInvGnd;
		expNodes = inInvInExp;
		andNodes = inInvAndPlane;

		numCells = expNodes.size();
		makeCells();
	}

	private void makeCells() {
		for (int n = 0; n < numCells; n++) {
			LayNode inNode = (LayNode) expNodes.get(n);
			LayNode pwrNode = (LayNode) pwrNodes.get(n);
			LayNode gndNode = (LayNode) gndNodes.get(n);
			LayNode andNode1 = (LayNode) andNodes.get(2 * n);
			LayNode andNode2 = (LayNode) andNodes.get(2 * n + 1);

			InInvCell cell = new InInvCell(inNode, pwrNode, gndNode, andNode1,
					andNode2, params, n, numNets, numContacts, numPins,
					numPmos, numNmos);
			// addArcs(cell.getArcs());
			// addNodes(cell.getNodes());
			nodeString += cell.getNodeString();
			arcString += cell.getArcString();

			numNets += cell.getNumNets();

			numContacts += cell.getNumContacts();

			numPins += cell.getNumPins();

			numNmos += cell.getNumNmos();

			numPmos += cell.getNumPmos();

			netCount += cell.getNumNets();

			contactCount += cell.getNumContacts();

			pinCount += cell.getNumPins();

			nmosCount += cell.getNumNmos();

			pmosCount += cell.getNumPmos();
		}
	}

	/*
	 * private void addArcs(Vector arcs) { int numAdds = arcs.size(); for(int n =
	 * 0; n<numAdds; n++){ layArcs.add(arcs.get(n)); } } private void
	 * addNodes(Vector nodes) { int numAdds = nodes.size(); for(int n = 0; n<numAdds;
	 * n++){ layNodes.add(nodes.get(n)); } } public Vector getNodes() { return
	 * layNodes; } public Vector getArcs() { return layArcs; }
	 */

	public int getNumNets() {
		return netCount;
	}

	public int getNumContacts() {
		return contactCount;
	}

	public int getNumPins() {
		return pinCount;
	}

	public int getNumPmos() {
		return pmosCount;
	}

	public int getNumNmos() {
		return nmosCount;
	}

	public String getNodeString() {
		return nodeString;
	}

	public String getArcString() {
		return arcString;
	}

}
