package plaGen;

public class InInvCell {

	// private Vector layArcs;
	// private Vector layNodes;
	private String nodeString;

	private String arcString;

	private LayNode inNode;

	private LayNode pwrNode;

	private LayNode gndNode;

	private LayNode andNode1;

	private LayNode andNode2;

	private Paramgetter params;

	private double m1Width;

	private double polyWidth;

	private double powerGndWidth;

	private double transToContact;

	private double m1M1Dist;

	private double nMosSize;

	private int numNets;

	private int netCount;

	private int numContacts;

	private int contactCount;

	private int numPins;

	private int pinCount;

	private int numNmos;

	private int nmosCount;

	private int numPmos;

	private int pmosCount;

	public InInvCell(LayNode in, LayNode pwr, LayNode gnd, LayNode and1,
			LayNode and2, Paramgetter p, int n, int nets, int contacts,
			int pins, int pmos, int nmos) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPins = pins;
		pinCount = 0;
		numNmos = nmos;
		nmosCount = 0;
		numPmos = pmos;
		pmosCount = 0;

		inNode = in;
		pwrNode = pwr;
		gndNode = gnd;
		andNode1 = and1;
		andNode2 = and2;
		params = p;

		m1Width = params.getM1Width();
		polyWidth = params.getPolyWidth();
		powerGndWidth = params.getPowerAndGndWide();
		transToContact = params.getTransistorToActiveConnection();
		m1M1Dist = params.getM1ToM1();
		nMosSize = params.getNMosInvWidth();

		makeCell();
	}

	private void makeCell() {
		String m1Arc = "Metal-1";
		String polyArc = "Polysilicon-1";
		String nArc = "N-Active";
		String pArc = "P-Active";

		LayNode pActiveL = makePActiveL();
		LayNode pActiveR = makePActiveR();
		LayNode pTrans = makePTrans();
		LayNode midM1 = makeMidPin();
		LayNode midPoly = makeMidPoly();
		LayNode sidePoly1 = makeSidePoly1();
		LayNode sidePoly2 = makeSidePoly2();
		LayNode sidePoly3 = makeSidePoly3();
		LayNode sidePoly4 = makeSidePoly4();
		LayNode sidePoly5 = makeSidePoly5();
		LayNode m1PolyViaR = makeM1PolyViaR();
		LayNode m1PolyViaL = makeM1PolyViaL();
		LayNode nActiveL = makeNActiveL();
		LayNode nActiveR = makeNActiveR();
		LayNode nTrans = makeNTrans();

		makeArc(m1Arc, pwrNode, pActiveL);
		makeArc(m1Arc, pActiveR, midM1);
		makeArc(m1Arc, midM1, m1PolyViaR);
		makeArc(m1Arc, midM1, nActiveR);
		makeArc(m1Arc, nActiveL, gndNode);
		makeArc(m1Arc, inNode, m1PolyViaL);

		makeArc(polyArc, m1PolyViaR, midPoly);
		makeArc(polyArc, midPoly, andNode2);
		makeArc(polyArc, nTrans, andNode1);
		makeArc(polyArc, pTrans, sidePoly1);
		makeArc(polyArc, sidePoly2, sidePoly1);
		makeArc(polyArc, sidePoly2, sidePoly3);
		makeArc(polyArc, m1PolyViaL, sidePoly3);
		makeArc(polyArc, sidePoly3, sidePoly4);
		makeArc(polyArc, sidePoly4, sidePoly5);
		makeArc(polyArc, sidePoly5, nTrans);

		makeArc(nArc, nActiveL, nTrans);
		makeArc(nArc, nTrans, nActiveR);

		makeArc(pArc, pActiveL, pTrans);
		makeArc(pArc, pTrans, pActiveR);

	}

	private LayNode makeM1PolyViaL() {
		String type = "Metal-1-Polysilicon-1-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = inNode.getX();
		double y = inNode.getY();
		double width = m1Width;
		double height = m1Width;
		String orientation = "";

		LayNode layNode = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// laynodes.add(layNode);
		nodeString += layNode.getText();
		return layNode;
	}

	private LayNode makeSidePoly5() {
		String type = "Polysilicon-1-Pin";
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		// System.out.println("pin@"+ String.valueOf(numPins));
		double x = inNode.getX() + (.5 * m1Width) + transToContact
				+ (.5 * polyWidth);
		double y = inNode.getY() + ((.5 * m1Width) + (.5 * polyWidth));
		double width = polyWidth;
		double height = polyWidth;
		String orientation = "";

		LayNode layNode = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// laynodes.add(layNode);
		nodeString += layNode.getText();
		return layNode;
	}

	private LayNode makeSidePoly4() {
		String type = "Polysilicon-1-Pin";
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		// System.out.println("pin@"+ String.valueOf(numPins));
		double x = inNode.getX() + (.5 * m1Width) - (.5 * polyWidth);
		double y = inNode.getY() + ((.5 * m1Width) + (.5 * polyWidth));
		double width = polyWidth;
		double height = polyWidth;
		String orientation = "";

		LayNode layNode = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// laynodes.add(layNode);
		nodeString += layNode.getText();
		return layNode;
	}

	private LayNode makeSidePoly3() {
		String type = "Polysilicon-1-Pin";
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		// System.out.println("pin@"+ String.valueOf(numPins));
		double x = inNode.getX() + (.5 * m1Width) - (.5 * polyWidth);
		double y = inNode.getY();
		double width = polyWidth;
		double height = polyWidth;
		String orientation = "";

		LayNode layNode = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// laynodes.add(layNode);
		nodeString += layNode.getText();
		return layNode;
	}

	private LayNode makeSidePoly2() {
		String type = "Polysilicon-1-Pin";
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		// System.out.println("pin@"+ String.valueOf(numPins));
		double x = inNode.getX() + (.5 * m1Width) - (.5 * polyWidth);
		double y = inNode.getY() - ((.5 * m1Width) + (.5 * polyWidth));
		double width = polyWidth;
		double height = polyWidth;
		String orientation = "";

		LayNode layNode = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// laynodes.add(layNode);
		nodeString += layNode.getText();
		return layNode;
	}

	private LayNode makeSidePoly1() {
		String type = "Polysilicon-1-Pin";
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		// System.out.println("pin@"+ String.valueOf(numPins));
		double x = inNode.getX() + (.5 * m1Width) + transToContact
				+ (.5 * polyWidth);
		double y = inNode.getY() - ((.5 * m1Width) + (.5 * polyWidth));
		double width = polyWidth;
		double height = polyWidth;
		String orientation = "";

		LayNode layNode = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// laynodes.add(layNode);
		nodeString += layNode.getText();
		return layNode;
	}

	private LayNode makeNTrans() {
		String type = "N-Transistor";
		String name = "nmos@" + String.valueOf(numNmos);
		nmosCount++;
		numNmos++;
		double x = gndNode.getX() + (.5 * m1Width) + transToContact
				+ (.5 * polyWidth);
		double y = gndNode.getY()
				- ((.5 * powerGndWidth) + m1M1Dist + (.5 * nMosSize));
		double width = nMosSize;
		double height = polyWidth;
		String orientation = "R";

		LayNode layNode = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// laynodes.add(layNode);
		nodeString += layNode.getText();
		return layNode;
	}

	private LayNode makeNActiveR() {
		String type = "Metal-1-N-Active-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = gndNode.getX() + m1Width + (2 * transToContact) + polyWidth;
		double y = gndNode.getY()
				- ((.5 * powerGndWidth) + m1M1Dist + (.5 * nMosSize));
		double width = m1Width;
		double height = nMosSize;
		String orientation = "";

		LayNode layNode = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// laynodes.add(layNode);
		nodeString += layNode.getText();
		return layNode;
	}

	private LayNode makeNActiveL() {
		String type = "Metal-1-N-Active-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = gndNode.getX();
		double y = gndNode.getY()
				- ((.5 * powerGndWidth) + m1M1Dist + (.5 * nMosSize));
		double width = m1Width;
		double height = nMosSize;
		String orientation = "";

		LayNode layNode = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// laynodes.add(layNode);
		nodeString += layNode.getText();
		return layNode;
	}

	private LayNode makeM1PolyViaR() {
		String type = "Metal-1-Polysilicon-1-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = andNode2.getX() - (.5 * polyWidth);
		double y = inNode.getY() + m1Width + m1M1Dist;
		double width = m1Width;
		double height = m1Width;
		String orientation = "";

		LayNode layNode = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// laynodes.add(layNode);
		nodeString += layNode.getText();
		return layNode;
	}

	private LayNode makeMidPoly() {
		String type = "Polysilicon-1-Pin";
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		// System.out.println("pin@"+ String.valueOf(numPins));
		double x = andNode2.getX();
		double y = inNode.getY() + m1Width + m1M1Dist;
		double width = polyWidth;
		double height = polyWidth;
		String orientation = "";

		LayNode layNode = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// laynodes.add(layNode);
		nodeString += layNode.getText();
		return layNode;
	}

	private LayNode makeMidPin() {
		String type = "Metal-1-Pin";
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		// System.out.println("pin@"+ String.valueOf(numPins));
		double x = gndNode.getX() + m1Width + (2 * transToContact) + polyWidth;
		double y = inNode.getY() + m1Width + m1M1Dist;
		double width = m1Width;
		double height = m1Width;
		String orientation = "";

		LayNode layNode = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// laynodes.add(layNode);
		nodeString += layNode.getText();
		return layNode;
	}

	private LayNode makePTrans() {
		String type = "P-Transistor";
		String name = "pmos@" + String.valueOf(numPmos);
		pmosCount++;
		numPmos++;
		double x = inNode.getX() + (.5 * m1Width) + transToContact
				+ (.5 * polyWidth);
		double y = inNode.getY()
				- ((.5 * m1Width) + m1M1Dist + (.5 * 2 * nMosSize));
		double width = (2 * nMosSize);
		double height = polyWidth;
		String orientation = "R";

		LayNode layNode = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// laynodes.add(layNode);
		nodeString += layNode.getText();
		return layNode;
	}

	private LayNode makePActiveR() {
		String type = "Metal-1-P-Active-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = gndNode.getX() + m1Width + (2 * transToContact) + polyWidth;
		double y = inNode.getY()
				- ((.5 * m1Width) + m1M1Dist + (.5 * 2 * nMosSize));
		double width = m1Width;
		double height = (2 * nMosSize);
		String orientation = "";

		LayNode layNode = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// laynodes.add(layNode);
		nodeString += layNode.getText();
		return layNode;
	}

	private LayNode makePActiveL() {
		String type = "Metal-1-P-Active-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = pwrNode.getX();
		double y = inNode.getY()
				- ((.5 * m1Width) + m1M1Dist + (.5 * 2 * nMosSize));
		double width = m1Width;
		double height = (2 * nMosSize);
		String orientation = "";

		LayNode layNode = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// laynodes.add(layNode);
		nodeString += layNode.getText();
		return layNode;
	}

	private void makeArc(String arcType, LayNode startNode, LayNode endNode) {
		String type = arcType;
		String name = "net@" + String.valueOf(numNets);
		netCount++;
		numNets++;
		String nameTD = "";
		double width = m1Width;
		if (type.equals("Polysilicon-1")) {
			width = polyWidth;
		} else if (type.equals("N-Active") || type.equals("P-Active")) {
			width = params.getActiveWidth();
		}
		String flags = "S";

		LayArc arc = new LayArc(type, name, nameTD, width, flags, startNode,
				endNode, params);
		// layArcs.add(arc);
		arcString += arc.getText();
	}

	/*
	 * public Vector getLayNodes() { return layNodes; } public Vector
	 * getLayArcs() { return layArcs; }
	 */
	public LayNode getAndNode1() {
		return andNode1;
	}

	public LayNode getAndNode2() {
		return andNode2;
	}

	public LayNode getGndNode() {
		return gndNode;
	}

	public LayNode getInNode() {
		return inNode;
	}

	public LayNode getPwrNode() {
		return pwrNode;
	}

	public int getNumNets() {
		return netCount;
	}

	public int getNumContacts() {
		return contactCount;
	}

	public int getNumPins() {
		return pinCount;
	}

	public int getNumPmos() {
		return pmosCount;
	}

	public int getNumNmos() {
		return nmosCount;
	}

	public String getNodeString() {
		return nodeString;
	}

	public String getArcString() {
		return arcString;
	}
}
