package plaGen;

public class LayArc {

	private String type;
	private String name;
	private String nameTD;
	private double width;
	private String flags;
	private String headName;
	private String headPortID;
	private double headX;
	private double headY;
	private String tailName;
	private String tailPortID;
	private double tailX;
	private double tailY;
	private Paramgetter params;
	private int angle;
	private LayNode headNode;
	private LayNode tailNode;
	private String printout;
	
	public LayArc(String t, String n, String nTD, double w, 
			String f, LayNode start, LayNode end, Paramgetter p) {
		
		headNode = start;
		tailNode = end;
		type = t;
		name = n;
		nameTD = nTD;
		width = w;
		headName = start.getName();
		headPortID = "";
		headX = start.getX();
		headY = start.getY();
		tailName = end.getName();
		tailPortID = "";
		tailX = end.getX();
		tailY = end.getY();
		angle = calcAngle();
		flags = f+String.valueOf(angle);
		params = p;
		corrections();
		printout =  "\nA" + type + "|" + name + "|" + nameTD + "|" + String.valueOf(width) + "|"
		+ flags + "|" + headName + "|" + headPortID + "|" + String.valueOf(headX) + "|"
		+ String.valueOf(headY) + "|" + tailName + "|" + tailPortID + "|"
		+ String.valueOf(tailX) + "|" + String.valueOf(tailY);
	}

	private int calcAngle() {
		
		double diffX = tailX - headX;
		double diffY = tailY - headY;
		int angle = 0;
		
		if (diffX > 0){
			angle = 1800;
		}
		else if (diffY > 0){
			angle = 2700;
		}
		else if (diffY < 0){
			angle = 900;
		}
		return angle;
	}

	private void corrections() {
		if (type.equals("N-Active") || type.equals("P-Active")){
			width +=12;
		}
		correctPortID();
	}
	
	private void correctPortID() {
		String heado = headNode.getOrientation();
		String tailo = tailNode.getOrientation();
		
		if((headName.substring(0, 4)).equals("nmos")){
			if(angle == 0){//top
				if(heado.equals("R")){
					headPortID = "n-trans-diff-top";
					headX -= ((.5 * params.getPolyWidth()) + 3);
				}
				else if(heado.equals("")){
					headPortID = "n-trans-poly-left";
					headX -= ((.5 * headNode.getWidth()) + 2 );
				}
			}
			else if(angle == 900){//left
				if(heado.equals("R")){
					headPortID = "n-trans-poly-left";
					headY -= ((.5 * headNode.getWidth()) + 2 );
				}
				if(heado.equals("")){
					headPortID = "n-trans-diff-bottom";
					headY -= ((.5 * params.getPolyWidth()) + 3);
				}
			}
			else if(angle == 1800){//bottom
				if(heado.equals("R")){
					headPortID = "n-trans-diff-bottom";	
					headX += ((.5 * params.getPolyWidth()) + 3);
				}
				else if(heado.equals("")){
					headPortID = "n-trans-poly-right";
					headX += ((.5 * headNode.getWidth()) + 2 );
				}
			}
			else{//right
				if(heado.equals("R")){
					headPortID = "n-trans-poly-right";
					headY += ((.5 * headNode.getWidth()) + 2 );
				}
				if(heado.equals("")){
					headPortID = "n-trans-diff-top";
					headY += ((.5 * params.getPolyWidth()) + 3);
				}
			}
			//System.out.println(this.getText());
		}
		else if ((headName.substring(0, 4)).equals("pmos")){
			if(angle == 0){//top
				if(heado.equals("R")){
					headPortID = "p-trans-diff-top";
					headX -= ((.5 * params.getPolyWidth()) + 3);
				}
				else if(heado.equals("")){
					headPortID = "p-trans-poly-left";
					headX -= (.5 *headNode.getWidth() + 2 );
				}
			}
			else if(angle == 900){//left
				if(heado.equals("R")){
					headPortID = "p-trans-poly-left";
					headY -= (.5 *headNode.getWidth() + 2 );
				}
				else if(heado.equals("")){
					headPortID = "p-trans-diff-bottom";	
					headY -= ((.5 * params.getPolyWidth()) + 3);
				}
			}
			else if(angle == 1800){//bottom
				if(heado.equals("R")){
					headPortID = "p-trans-diff-bottom";	
					headX += ((.5 * params.getPolyWidth()) + 3);
				}
				else if(heado.equals("")){
					headPortID = "p-trans-poly-right";
					headX += (.5 *headNode.getWidth() + 2 );
				}
			}
			else{//right
				if(heado.equals("R")){
					headPortID = "p-trans-poly-right";
					headY += (.5 *headNode.getWidth() + 2 );
				}
				if(heado.equals("")){
					headPortID = "p-trans-diff-top";
					headY += ((.5 * params.getPolyWidth()) + 3);
				}
			}
		}
		if((tailName.substring(0, 4)).equals("nmos")){
			if(angle == 0){//bottom
				if(tailo.equals("R")){
					tailPortID = "n-trans-diff-bottom";
					tailX += ((.5 * params.getPolyWidth()) + 3);
				}
				else if(tailo.equals("")){
					tailPortID = "n-trans-poly-right";
					tailX += ((.5 * tailNode.getWidth()) + 2 );
				}
			}
			else if(angle == 900){//right
				if(tailo.equals("R")){
					tailPortID = "n-trans-poly-right";
					tailY += ((.5 * tailNode.getWidth()) + 2 );
				}
				else if(tailo.equals("")){
					tailPortID = "n-trans-diff-top";
					tailY += ((.5 * params.getPolyWidth()) + 3);
				}
			}
			else if(angle == 1800){//top
				if(tailo.equals("R")){
					tailPortID = "n-trans-diff-top";
					tailX -= ((.5 * params.getPolyWidth()) + 3);
				}
				else if(tailo.equals("")){
					tailPortID = "n-trans-poly-left";
					tailX -= ((.5 * tailNode.getWidth()) + 2 );
				}
			}
			else {//left
				if(tailo.equals("R")){
					tailPortID = "n-trans-poly-left";
					tailY -= ((.5 * tailNode.getWidth()) + 2 );
				}
				else if(tailo.equals("")){
					tailPortID = "n-trans-diff-bottom";
					tailY -= ((.5 * params.getPolyWidth()) + 3);
				}
			}
		}
		else if ((tailName.substring(0, 4)).equals("pmos")){
			if(angle == 0){//bottom
				if(tailo.equals("R")){
					tailPortID = "p-trans-diff-bottom";
					tailX += ((.5 * params.getPolyWidth()) + 3);
				}
				else if(tailo.equals("")){
					tailPortID = "p-trans-poly-right";
					tailX += (.5 * tailNode.getWidth() + 2 );
				}
			}
			else if(angle == 900){//right
				if(tailo.equals("R")){
					tailPortID = "p-trans-poly-right";
					tailY += (.5 * tailNode.getWidth() + 2 );
				}
				else if(tailo.equals("")){
					tailPortID = "p-trans-diff-top";
					tailY += ((.5 * params.getPolyWidth()) + 3);
				}
			}
			else if(angle == 1800){//top
				if(tailo.equals("R")){
					tailPortID = "p-trans-diff-top";
					tailX -= ((.5 * params.getPolyWidth()) + 3);
				}
				else if(tailo.equals("")){
					tailPortID = "p-trans-poly-left";
					tailX -= (.5 * tailNode.getWidth() + 2 );
				}
			}
			else {//left
				if(tailo.equals("R")){
					tailPortID = "p-trans-poly-left";
					tailY -= (.5 * tailNode.getWidth() + 2 );
				}
				else if(tailo.equals("")){
					tailPortID = "p-trans-diff-bottom";
					tailX -= ((.5 * params.getPolyWidth()) + 3);
				}
			}
		}
	}

	public String getText() {
		//System.out.print(printout);
		return printout;
	}

}
