package plaGen;

/*
 *  Class: LayNode
 *  
 *  Purpose/function:  Takes in all attributes of a layout node and makes those
 *  values available for reference;  method "getText() can be called to return 
 *  the string equivalent of the layout node, for use in electric.
 */
public class LayNode {

	private String type;
	private String name;
	private String nameTD;
	private double x;
	private double y;
	private double width;
	private double trueWidth;
	private double height;
	private double trueHeight;
	private String orientation;
	private String flags;
	private String printout;
	
	
	public LayNode(String t, String n, String nTD, double xx, double yy,
			double wide, double high, String o, String f){
		type = t;
		name = n;
		nameTD = nTD;
		x = xx;
		y = yy;
		width = wide;
		trueWidth = width;
		height = high;
		trueHeight = height;
		orientation = o;
		flags = f;
		corrections(type);
		printout = "\nN" + type + "|" + name + "|" + nameTD + "|" + String.valueOf(x) 
		+ "|" + String.valueOf(y) + "|" 
		+ String.valueOf(width) + "|" + String.valueOf(height) + "|" + orientation 
		+ "|" + flags;
	}
	
	public LayNode(String t, String n, String nTD, double xx, double yy,
			double wide, double high, String o, String f,String vars){
		type = t;
		name = n;
		nameTD = nTD;
		x = xx;
		y = yy;
		width = wide;
		trueWidth = width;
		height = high;
		trueHeight = height;
		orientation = o;
		flags = f;
		corrections(type);
		printout = "\nN" + type + "|" + name + "|" + nameTD + "|" + String.valueOf(x) 
		+ "|" + String.valueOf(y) + "|" 
		+ String.valueOf(width) + "|" + String.valueOf(height) + "|" + orientation 
		+ "|" + flags + "|" + vars;
	}
	
	private void corrections(String t) {
		
		if(t.equals("Metal-1-Polysilicon-1-Con") || t.equals("Metal-1-Metal-2-Con")){
			width++;
			height++;
		}
		else if(t.equals("Metal-1-N-Active-Con")||t.equals("Metal-1-P-Active-Con")
				||t.equals("Metal-1-N-Well-Con")||t.equals("Metal-1-P-Well-Con")){
			width+=13;
			height+=13;
		}
		/*
		else if(t.equals("Polysilicon-1-Pin")
				||t.equals("Metal-1-Pin")||t.equals("Metal-2-Pin")){
			height--;
			width--;
		}
		*/
		else if(t.equals("P-Transistor")||t.equals("N-Transistor")){
			height += 20;
			width += 12;
		}
		else if(t.equals("N-Active-Pin")||t.equals("P-Active-Pin")){
			height += 12;
			width += 12;
		}
	}

	public String getText(){
		//System.out.print(printout);
		return printout;
	}

	public String getFlags() {
		return flags;
	}

	public double getHeight() {
		return trueHeight;
	}

	public String getName() {
		return name;
	}

	public String getNameTD() {
		return nameTD;
	}

	public String getOrientation() {
		return orientation;
	}

	public String getType() {
		return type;
	}

	public double getWidth() {
		return trueWidth;
	}

	public double getX() {
		return x;
	}

	public double getY() {
		return y;
	}
}

	