package plaGen;

public class LowGndLegCell {

	// private Vector layArcs;
	// private Vector layNodes;
	private String nodeString;

	private String arcString;

	private LayNode startNode;

	private LayNode endNode;

	private Paramgetter params;

	private int numNets;

	private int netCount;

	private int numPWells;

	private int pwellCount;

	public LowGndLegCell(LayNode sNode, LayNode eNode, Paramgetter p, int n,
			int nets, int pins, int pwells) {

		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numPWells = pwells;
		pwellCount = 0;

		startNode = sNode;
		endNode = eNode;
		params = p;

		makeCell();
	}

	private void makeCell() {
		LayNode wellNode = makeWellNode();
		makeVertArc(wellNode, startNode);
		makeHorArc(startNode, endNode);
	}

	private void makeHorArc(LayNode node1, LayNode node2) {
		String type = "Metal-1";
		String name = "net@" + String.valueOf(numNets);
		netCount++;
		numNets++;
		String nameTD = "";
		double width = params.getPowerAndGndWide();
		String flags = "S";
		LayArc arc = new LayArc(type, name, nameTD, width, flags, node1, node2,
				params);
		// arcs.add(arc);
		arcString += arc.getText();

	}

	private void makeVertArc(LayNode node1, LayNode node2) {
		String type = "Metal-1";
		String name = "net@" + String.valueOf(numNets);
		netCount++;
		numNets++;
		String nameTD = "";
		double width = params.getM1Width();
		String flags = "S";
		LayArc arc = new LayArc(type, name, nameTD, width, flags, node1, node2,
				params);
		// arcs.add(arc);
		arcString += arc.getText();

	}

	private LayNode makeWellNode() {
		String type = "Metal-1-P-Well-Con";
		String name = "well@" + String.valueOf(numPWells);
		pwellCount++;
		numPWells++;
		String nameTD = "";
		double x = startNode.getX();
		double y = startNode.getY();
		double w = params.getM1Width();
		double h = w;
		String o = "";
		String flags = "V";
		LayNode node = new LayNode(type, name, nameTD, x, y, w, h, o, flags);
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	/*
	 * public Vector getArcs() { return arcs; } public Vector getNodes() {
	 * return nodes; }
	 */
	public int getNumNets() {
		return netCount;
	}

	public int getNumPWells() {
		return pwellCount;
	}

	public String getNodeString() {
		return nodeString;
	}

	public String getArcString() {
		return arcString;
	}

}
