package plaGen;

import java.util.Vector;

public class OrPlane {

	private Vector orPull;
	private Vector andPlane;
	private Vector outInv;
	
	//	private Vector layArcs;
	//private Vector layNodes;
	private String nodeString;
	private String arcString;
	
	private Paramgetter params;
	private Caseinfo info;
	
	private int numNets;
	private int netCount;

	private int numContacts;
	private int contactCount;
	
	private int numPins;
	private int pinCount;
	
	private int numNmos;
	private int nmosCount;
	
	private int numPWells;
	private int pwellCount;
	
	public OrPlane(Vector orPlaneAndPlane, Vector orPlaneOrPull, Vector outInvOrPlane, Paramgetter p,
			Caseinfo i, int nets, int contacts, int pins, int nmos, int pwells) {
		//nodes = new Vector(10,10);
		//arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";
		
		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPins = pins;
		pinCount = 0;
		numNmos = nmos;
		nmosCount = 0;
		numPWells = pwells;
		pwellCount = 0;
		
		andPlane = orPlaneAndPlane;
		orPull = orPlaneOrPull;
		outInv = outInvOrPlane;
		params = p;
		info = i;
		makeCells();
	}

	private void makeCells() {
		int[][] orPlane = info.getOutputMatrix();
		
		int numCases = info.getNumCases();
		int numRows = (int)Math.ceil(.5 * numCases);
		int numOutBits = info.getNumOutputBits();
		int numCols = (int)Math.ceil(.5 * numOutBits);
		
		OrPlaneCell[][] cells= new OrPlaneCell[numRows][numCols];
		OrPlaneCell cell = null;
		LayNode upperLeftIn = null;
		LayNode lowerLeftIn = null;
		LayNode leftBottomIn = null;
		LayNode midBottomIn = null;
		LayNode rightBottomIn = null;
		
		LayNode leftTopOut = null;
		LayNode midTopOut = null;
		LayNode rightTopOut = null;
		
		LayNode leftBottomAltIn = null;
		LayNode rightBottomAltIn = null;
		
		LayNode dummyNode = makeDummy();
		
		int upperLeft = 0;
		int upperRight = 0;
		int lowerLeft = 0;
		int lowerRight = 0;
		
		for(int row = 0 ; row < numRows ; row++){
			boolean endFlag = (row == numRows-1);
			for(int col = 0 ; col < numCols ; col++ ){
				if(endFlag){
					leftTopOut = (LayNode) orPull.get(3*col);
					midTopOut = (LayNode) orPull.get((3*col)+1);
					if(isEven(numOutBits)||(col < (numCols-1))){
						rightTopOut = (LayNode) orPull.get((3*col)+2);
					}
				}
				if(row > 0 && (isEven(numOutBits)||(col<numCols-1))){ // NOT zeroth row, not funky row
					//System.out.println("tester1");
					leftBottomAltIn = cells[row-1][col].getAltOutL();
					rightBottomAltIn = cells[row-1][col].getAltOutR();
					leftBottomIn = cells[row-1][col].getLeftHiOut();
					rightBottomIn = cells[row-1][col].getRightHiOut();
					midBottomIn = cells[row-1][col].getMidHiOut();
					lowerLeft = orPlane[2*row][2*col];
					lowerRight = orPlane[2*row][(2*col)+1];
					
				}
				else if (row == 0 && (isEven(numOutBits)||(col < (numCols-1)))){  // non funky zeroth row
					//System.out.println("tester2");
					leftBottomAltIn = dummyNode;
					rightBottomAltIn = dummyNode;
					leftBottomIn = (LayNode) outInv.get(3*col);
					rightBottomIn = (LayNode) outInv.get((3 * col)+2);
					midBottomIn = (LayNode)outInv.get((3 * col)+1);
				}
				else if (row == 0){ //funky end of zero row
					leftBottomAltIn = dummyNode;
					leftBottomIn = (LayNode) outInv.get(3*col);
					midBottomIn = (LayNode)outInv.get((3 * col)+1);
					lowerLeft = orPlane[2*row][2*col];
				}
				else { // funky end of normal row
					leftBottomAltIn = cells[row-1][col].getAltOutL();
					leftBottomIn = cells[row-1][col].getLeftHiOut();
					midBottomIn = cells[row-1][col].getMidHiOut();
				}
				
				// bulk: NOT zeroth column, not top row unless even # cases
				if((col > 0) && ((isEven(numCases))||(row<numRows-1))){
					//System.out.println("tester3");
					upperLeftIn = cells[row][col - 1].getUpperRightOut();
					lowerLeftIn = cells[row][col - 1].getLowerRightOut();
				}
				// zeroth column, not top row unless even # cases
				else if ((col == 0) && ((isEven(numCases))||(row<numRows-1))){
					//System.out.println("tester4");
					upperLeftIn = (LayNode) andPlane.get((2 * row)+1);
					lowerLeftIn = (LayNode) andPlane.get(2 * row);
				}
				// top row, NOT zeroth column, odd # of cases
				else if (col > 0){ 
					lowerLeftIn = cells[row][col - 1].getLowerRightOut();
				}
				else{
					lowerLeftIn = (LayNode) andPlane.get(2 * row);
				}
				
				
				//general
				if(((col < (numCols-1))||(isEven(numOutBits)))&&((row < (numRows-1))||(isEven(numCases)))){
					upperLeft = orPlane[(2*row)+1][(2*col)];
					lowerLeft = orPlane[(2*row)][(2*col)];
					upperRight = orPlane[(2*row)+1][(2*col)+1];
					lowerRight = orPlane[(2*row)][(2*col)+1];
					
					cell = new OrPlaneCell(upperLeftIn,lowerLeftIn,row,col,leftBottomIn,midBottomIn,
							rightBottomIn,leftBottomAltIn,rightBottomAltIn,params,lowerLeft,
							lowerRight,upperLeft,upperRight, endFlag,leftTopOut,midTopOut,rightTopOut,numNets,numContacts,
							numPins,numNmos,numPWells);
				}
				//missing top half
				else if ((col < (numCols -1)) && (row == (numRows-1))){
					lowerLeft = orPlane[(2*row)][(2*col)];
					lowerRight = orPlane[(2*row)][(2*col)+1];
					
					cell = new OrPlaneCell(lowerLeftIn,row,col,leftBottomIn,midBottomIn,
							rightBottomIn,leftBottomAltIn,rightBottomAltIn,params,lowerLeft,
							lowerRight,leftTopOut,midTopOut,rightTopOut,numNets,numContacts,
							numPins,numNmos,numPWells);
				}
				//missing right half
				else if ((col == (numCols -1)) && (row < (numRows -1))){
					upperLeft = orPlane[(2*row)+1][(2*col)];
					lowerLeft = orPlane[(2*row)][(2*col)];
					
					cell = new OrPlaneCell(upperLeftIn,lowerLeftIn,row,col,leftBottomIn,midBottomIn,
							leftBottomAltIn,params,lowerLeft,upperLeft,endFlag,
							leftTopOut,midTopOut,numNets,numContacts,
							numPins,numNmos,numPWells);
				}
				//missing top and right
				else{
					lowerLeft = orPlane[(2*row)][(2*col)];
					
					cell = new OrPlaneCell(lowerLeftIn,row,col,leftBottomIn,midBottomIn,leftBottomAltIn,
							params,lowerLeft,leftTopOut,midTopOut,numNets,numContacts,
							numPins,numNmos,numPWells);
				}
				cells[row][col] = cell;
				
				//addArcs(cell.getArcs());
				//addNodes(cell.getNodes());
				nodeString += cell.getNodeString();
				arcString += cell.getArcString();
				
				numNets += cell.getNumNets();
				
				numContacts += cell.getNumContacts();

				numPins += cell.getNumPins();
			
				numNmos += cell.getNumNmos();
			
				numPWells += cell.getNumPWells();
				
				netCount += cell.getNumNets();
				
				contactCount += cell.getNumContacts();

				pinCount += cell.getNumPins();
			
				nmosCount += cell.getNumNmos();
			
				pwellCount += cell.getNumPWells();
			}
		}
	}

	private LayNode makeDummy() {
		String name = "";
		double x = 0;
		double y = 0;
		double width = 0;
		double height = 0;
		String orientation = "";
		LayNode node = new LayNode("",name,"",x,y,width,height,orientation,"");
		return node;
	}

	private boolean isEven(int n) {
		return (n%2==0);
	}
/*
	private void addArcs(Vector vA) {
		int numAdds = vA.size();
		for(int n = 0; n<numAdds; n++){
			arcs.add(vA.get(n));
		}
	}

	private void addNodes(Vector vN) {
		int numAdds = vN.size();
		for(int n = 0; n<numAdds; n++){
			nodes.add(vN.get(n));
		}
	}
	
	public Vector getNodes() {
		return nodes;
	}

	public Vector getArcs() {
		return arcs;
	}
*/
	public int getNumNets() {
		return netCount;
	}

	public int getNumContacts() {
		return contactCount;
	}

	public int getNumPins() {
		return pinCount;
	}

	public int getNumNmos() {
		return nmosCount;
	}

	public int getNumPWells() {
		return pwellCount;
	}

	public String getNodeString() {
		return nodeString;
	}

	public String getArcString() {
		return arcString;
	}
}
