package plaGen;

public class OrPlaneCell {

	// private Vector layArcs;
	// private Vector layNodes;
	private String nodeString;

	private String arcString;

	private LayNode hiLIn;

	private LayNode loLIn;

	private LayNode bottomMIn;

	private LayNode bottomLIn;

	private LayNode bottomRIn;

	private LayNode bottomLAltIn;

	private LayNode bottomRAltIn;

	private LayNode topRAltOut;

	private LayNode topLAltOut;

	private LayNode hiROut;

	private LayNode loROut;

	private LayNode topMOut;

	private LayNode topLOut;

	private LayNode topROut;

	private LayNode midLPin;

	private LayNode midMWell;

	private LayNode midRPin;

	private LayNode endTopL;

	private LayNode endTopMid;

	private LayNode endTopR;

	private LayNode poly1;

	private LayNode poly2;

	private Paramgetter params;

	private int row;

	private int loLBit;

	private int hiLBit;

	private int loRBit;

	private int hiRBit;

	private String m1Net;

	private String polyNet;

	private String actNet;

	private String m1Pin;

	private String polyPin;

	private String actPin;

	private String actCon;

	private String nmos;

	private String pwell;

	private double m1W;

	private double polyW;

	private double transActD;

	private double m1M1D;

	private int numNets;

	private int netCount;

	private int numContacts;

	private int contactCount;

	private int numPins;

	private int pinCount;

	private int numNmos;

	private int nmosCount;

	private int numPWells;

	private int pwellCount;

	// general
	public OrPlaneCell(LayNode upperLeftIn, LayNode lowerLeftIn, int r, int c,
			LayNode leftBottomIn, LayNode midBottomIn, LayNode rightBottomIn,
			LayNode leftBottomAltIn, LayNode rightBottomAltIn, Paramgetter p,
			int lowerLeft, int lowerRight, int upperLeft, int upperRight,
			boolean endFlag, LayNode leftTopOut, LayNode midTopOut,
			LayNode rightTopOut, int nets, int contacts, int pins, int nmo,
			int pwells) {

		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPins = pins;
		pinCount = 0;
		numNmos = nmo;
		nmosCount = 0;
		numPWells = pwells;
		pwellCount = 0;

		m1Net = "Metal-1";
		polyNet = "Polysilicon-1";
		actNet = "N-Active";

		m1Pin = "Metal-1-Pin";
		polyPin = "Polysilicon-1-Pin";
		actPin = "N-Active-Pin";
		actCon = "Metal-1-N-Active-Con";
		nmos = "N-Transistor";
		pwell = "Metal-1-P-Well-Con";

		params = p;
		m1W = params.getM1Width();
		polyW = params.getPolyWidth();
		transActD = params.getTransistorToActiveConnection();
		m1M1D = params.getM1ToM1();

		hiLIn = upperLeftIn;
		loLIn = lowerLeftIn;

		bottomMIn = midBottomIn;
		bottomLIn = leftBottomIn;
		bottomRIn = rightBottomIn;

		bottomLAltIn = leftBottomAltIn;
		bottomRAltIn = rightBottomAltIn;

		hiROut = null;
		loROut = null;
		topMOut = null;
		topLOut = null;
		topROut = null;

		topLAltOut = null;
		topRAltOut = null;

		midLPin = makeMidLM1Pin();
		midMWell = makeMidMPWell();
		midRPin = makeMidRM1Pin();

		poly1 = null;
		poly2 = null;

		row = r;
		loLBit = lowerLeft;
		hiLBit = upperLeft;
		loRBit = lowerRight;
		hiRBit = upperRight;

		if (row == 0) {
			// System.out.println("firstRow");
			correctLowInputLM();
			correctLowInputR();
		}
		/*
		 * if(col == 0){ correctLeftInputLo(); correctLeftInputHi(); }
		 */
		makeLL();
		makeLR();
		makeUL();
		makeUR();

		if (endFlag) {
			// System.out.println("endInsideGeneral");
			endTopL = leftTopOut;
			endTopMid = midTopOut;
			endTopR = rightTopOut;
			linkUpL();
			linkUpR();
		}
	}

	// missing top
	public OrPlaneCell(LayNode lowerLeftIn, int r, int c, LayNode leftBottomIn,
			LayNode midBottomIn, LayNode rightBottomIn,
			LayNode leftBottomAltIn, LayNode rightBottomAltIn, Paramgetter p,
			int lowerLeft, int lowerRight, LayNode leftTopOut,
			LayNode midTopOut, LayNode rightTopOut, int nets, int contacts,
			int pins, int nmo, int pwells) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPins = pins;
		pinCount = 0;
		numNmos = nmo;
		nmosCount = 0;
		numPWells = pwells;
		pwellCount = 0;

		m1Net = "Metal-1";
		polyNet = "Polysilicon-1";
		actNet = "N-Active";

		m1Pin = "Metal-1-Pin";
		polyPin = "Polysilicon-1-Pin";
		actPin = "N-Active-Pin";
		actCon = "Metal-1-N-Active-Con";
		nmos = "N-Transistor";
		pwell = "Metal-1-P-Well-Con";

		loLIn = lowerLeftIn;
		bottomMIn = midBottomIn;
		bottomLIn = leftBottomIn;
		bottomRIn = rightBottomIn;

		bottomLAltIn = leftBottomAltIn;
		bottomRAltIn = rightBottomAltIn;

		params = p;
		m1W = params.getM1Width();
		polyW = params.getPolyWidth();
		transActD = params.getTransistorToActiveConnection();
		m1M1D = params.getM1ToM1();

		midLPin = makeMidLM1Pin();
		midMWell = makeMidMPWell();
		midRPin = makeMidRM1Pin();

		loROut = null;

		topMOut = midMWell;
		topLOut = midLPin;
		topROut = midRPin;

		poly1 = null;
		poly2 = null;

		row = r;
		loLBit = lowerLeft;
		loRBit = lowerRight;

		if (row == 0) {
			correctLowInputLM();
			correctLowInputR();
		}
		/*
		 * if(col == 0){ correctLeftInputLo(); }
		 */
		makeLL();
		makeLR();

		endTopL = leftTopOut;
		endTopMid = midTopOut;
		endTopR = rightTopOut;
		linkUpL();
		linkUpR();
	}

	// missing right
	public OrPlaneCell(LayNode upperLeftIn, LayNode lowerLeftIn, int r, int c,
			LayNode leftBottomIn, LayNode midBottomIn, LayNode leftBottomAltIn,
			Paramgetter p, int lowerLeft, int upperLeft, boolean endFlag,
			LayNode leftTopOut, LayNode midTopOut, int nets, int contacts,
			int pins, int nmo, int pwells) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPins = pins;
		pinCount = 0;
		numNmos = nmo;
		nmosCount = 0;
		numPWells = pwells;
		pwellCount = 0;

		m1Net = "Metal-1";
		polyNet = "Polysilicon-1";
		actNet = "N-Active";

		m1Pin = "Metal-1-Pin";
		polyPin = "Polysilicon-1-Pin";
		actPin = "N-Active-Pin";
		actCon = "Metal-1-N-Active-Con";
		nmos = "N-Transistor";
		pwell = "Metal-1-P-Well-Con";

		params = p;
		m1W = params.getM1Width();
		polyW = params.getPolyWidth();
		transActD = params.getTransistorToActiveConnection();
		m1M1D = params.getM1ToM1();

		hiLIn = upperLeftIn;
		loLIn = lowerLeftIn;
		bottomMIn = midBottomIn;
		bottomLIn = leftBottomIn;

		bottomLAltIn = leftBottomAltIn;

		midLPin = makeMidLM1Pin();
		midMWell = makeMidMPWell();

		topMOut = null;
		topLOut = null;
		topROut = null;

		topLAltOut = null;

		poly1 = null;
		poly2 = null;

		row = r;
		loLBit = lowerLeft;
		hiLBit = upperLeft;

		if (row == 0) {
			correctLowInputLM();
		}

		/*
		 * if(col == 0){ correctLeftInputLo(); correctLeftInputHi(); }
		 */
		makeLL();
		makeUL();

		if (endFlag) {
			// System.out.println("EndflagFarRight");
			topMOut = midMWell;
			topLOut = midLPin;
			endTopL = leftTopOut;
			endTopMid = midTopOut;
			linkUpL();
		}
	}

	// missing top and right
	public OrPlaneCell(LayNode lowerLeftIn, int r, int c, LayNode leftBottomIn,
			LayNode midBottomIn, LayNode leftBottomAltIn, Paramgetter p,
			int lowerLeft, LayNode leftTopOut, LayNode midTopOut, int nets,
			int contacts, int pins, int nmo, int pwells) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPins = pins;
		pinCount = 0;
		numNmos = nmo;
		nmosCount = 0;
		numPWells = pwells;
		pwellCount = 0;

		loLIn = lowerLeftIn;

		bottomMIn = midBottomIn;
		bottomLIn = leftBottomIn;

		bottomLAltIn = leftBottomAltIn;

		m1Net = "Metal-1";
		polyNet = "Polysilicon-1";
		actNet = "N-Active";

		m1Pin = "Metal-1-Pin";
		polyPin = "Polysilicon-1-Pin";
		actPin = "N-Active-Pin";
		actCon = "Metal-1-N-Active-Con";
		nmos = "N-Transistor";
		pwell = "Metal-1-P-Well-Con";

		poly1 = null;
		poly2 = null;

		params = p;
		m1W = params.getM1Width();
		polyW = params.getPolyWidth();
		transActD = params.getTransistorToActiveConnection();
		m1M1D = params.getM1ToM1();

		row = r;
		midLPin = makeMidLM1Pin();
		midMWell = makeMidMPWell();

		loLBit = lowerLeft;

		if (row == 0) {
			correctLowInputLM();
		}
		/*
		 * if(col == 0){ correctLeftInputLo(); }
		 */
		makeLL();

		topMOut = midMWell;
		topLOut = midLPin;

		endTopL = leftTopOut;
		endTopMid = midTopOut;
		linkUpL();
	}

	private void linkUpL() {
		makeArc(topLOut, endTopL, m1Net);
		makeArc(topMOut, endTopMid, m1Net);
	}

	private void linkUpR() {
		makeArc(topROut, endTopR, m1Net);
	}

	private void makeLL() {

		if (loLBit == 1) {
			if (!bottomLAltIn.getType().equals("N-Active-Pin")) {
				// System.out.println("bitTest1");
				LayNode lowAct = makeLoLeftActivePin();
				bottomLAltIn = lowAct;
			}
			if (bottomMIn.getType().equals("Metal-1-Pin")) {
				// System.out.println("bitTest2");
				LayNode midActive = makeMiddleBottomActiveCon();
				makeArc(midActive, bottomMIn, m1Net);
				bottomMIn = midActive;
			}
			// System.out.println("bitTest3");
			LayNode loLeftAct = makeLoLeftActiveCon();
			poly1 = makeLoLeftTrans();
			makeArc(bottomLIn, loLeftAct, m1Net);
			makeArc(loLeftAct, midLPin, m1Net);// ***********
			makeArc(loLeftAct, poly1, actNet);
			makeArc(poly1, bottomLAltIn, actNet);
			makeArc(bottomLAltIn, bottomMIn, actNet);

		} else {
			// System.out.println("bitTest4");
			makeArc(bottomLIn, midLPin, m1Net);// **********
			poly1 = makeLoLeftPolyPin();
		}
		makeArc(midMWell, bottomMIn, m1Net);// ************
		makeArc(loLIn, poly1, polyNet);
	}

	private void correctLowInputLM() {
		LayNode nodeL = makeLowLeftM1Pin();
		LayNode nodeM = makeLowMidM1Pin();
		makeArc(nodeL, bottomLIn, m1Net);
		makeArc(nodeM, bottomMIn, m1Net);
		bottomLIn = nodeL;
		bottomMIn = nodeM;
	}

	private void correctLowInputR() {
		LayNode node = makeLowRightM1Pin();
		makeArc(node, bottomRIn, m1Net);
		bottomRIn = node;
	}

	private void makeLR() {
		if (loRBit == 1) {
			if (!bottomRAltIn.getType().equals("N-Active-Pin")) {
				LayNode lowRAct = makeLoRightActivePin();
				bottomRAltIn = lowRAct;
			}
			if (bottomMIn.getType().equals("Metal-1-Pin")) {
				LayNode midActive = makeMiddleBottomActiveCon();
				makeArc(midActive, bottomMIn, m1Net);
				bottomMIn = midActive;
			}
			LayNode loRightAct = makeLoRightActiveCon();
			loROut = makeLoRightTrans();
			makeArc(bottomRAltIn, bottomMIn, actNet);
			makeArc(bottomRAltIn, loROut, actNet);
			makeArc(loROut, loRightAct, actNet);
			makeArc(bottomRIn, loRightAct, m1Net);
			makeArc(loRightAct, midRPin, m1Net);
		} else {
			loROut = makeLoRightPolyPin();
			makeArc(bottomRIn, midRPin, m1Net);
		}
		makeArc(loROut, poly1, polyNet);
	}

	private void makeUL() {

		topLOut = makeUpperLeftM1Pin();

		if (hiLBit == 1) {
			topMOut = makeTopMidActiveCon();
			topLAltOut = makeTopLeftActPin();
			LayNode hiLeftAct = makeHiLeftActiveCon();
			poly2 = makeHiLeftTrans();
			makeArc(topLAltOut, topMOut, actNet);
			makeArc(topLAltOut, poly2, actNet);
			makeArc(poly2, hiLeftAct, actNet);
			makeArc(midLPin, hiLeftAct, m1Net);
			makeArc(hiLeftAct, topLOut, m1Net);
		} else {
			poly2 = makeHiLeftPolyPin();
			topMOut = makeTopMidM1Pin();
			topLAltOut = makeDummy();
			makeArc(midLPin, topLOut, m1Net);// ********************
		}
		makeArc(hiLIn, poly2, polyNet);
		makeArc(midMWell, topMOut, m1Net);// *****************
	}

	private void makeUR() {
		topROut = makeUpperRightM1Pin();

		if (hiRBit == 1) {
			if (topMOut.getType().equals("Metal-1-Pin")) {
				LayNode midActive = makeTopMidActiveCon();
				makeArc(midActive, topMOut, m1Net);
				topMOut = midActive;
			}
			topRAltOut = makeTopRightActPin();
			LayNode hiRightAct = makeHiRightActiveCon();
			hiROut = makeHiRightTrans();
			makeArc(topRAltOut, topMOut, actNet);
			makeArc(topRAltOut, hiROut, actNet);
			makeArc(hiROut, hiRightAct, actNet);
			makeArc(midRPin, hiRightAct, m1Net);
			makeArc(hiRightAct, topROut, m1Net);
		} else {
			hiROut = makeHiRightPolyPin();
			topRAltOut = makeDummy();
			makeArc(midRPin, topROut, m1Net);// ****************
		}
		makeArc(poly2, hiROut, polyNet);
	}

	private LayNode makeMidMPWell() {
		String name = "well@" + String.valueOf(numPWells);
		pwellCount++;
		numPWells++;
		double x = bottomMIn.getX();
		double y = loLIn.getY()
				+ ((.5 * m1W) + (.5 * polyW) + transActD + m1M1D);
		double width = m1W;
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(pwell, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeHiRightTrans() {
		String name = "nmos@" + String.valueOf(numNmos);
		nmosCount++;
		numNmos++;
		double x = bottomRIn.getX();
		double y = hiLIn.getY();
		double width = params.getM1Width();
		double height = params.getPolyWidth();
		String orientation = "";
		LayNode node = new LayNode(nmos, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeHiLeftTrans() {
		String name = "nmos@" + String.valueOf(numNmos);
		nmosCount++;
		numNmos++;
		double x = bottomLIn.getX();
		double y = hiLIn.getY();
		double width = params.getM1Width();
		double height = params.getPolyWidth();
		String orientation = "";
		LayNode node = new LayNode(nmos, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeLoRightTrans() {
		String name = "nmos@" + String.valueOf(numNmos);
		nmosCount++;
		numNmos++;
		double x = bottomRIn.getX();
		double y = loLIn.getY();
		double width = params.getM1Width();
		double height = params.getPolyWidth();
		String orientation = "";
		LayNode node = new LayNode(nmos, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeLoLeftTrans() {
		String name = "nmos@" + String.valueOf(numNmos);
		nmosCount++;
		numNmos++;
		double x = bottomLIn.getX();
		double y = loLIn.getY();
		double width = params.getM1Width();
		double height = params.getPolyWidth();
		String orientation = "";
		LayNode node = new LayNode(nmos, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeTopRightActPin() {
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = bottomRIn.getX();
		double y = hiLIn.getY() + ((.5 * polyW) + (.5 * m1W) + transActD);
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(actPin, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeLoRightActivePin() {
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = bottomRIn.getX();
		double y = loLIn.getY() - ((.5 * polyW) + (.5 * m1W) + transActD);
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(actPin, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeLoLeftActivePin() {
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = bottomLIn.getX();
		double y = loLIn.getY() - ((.5 * polyW) + (.5 * m1W) + transActD);
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(actPin, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeTopLeftActPin() {
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = bottomLIn.getX();
		double y = hiLIn.getY() + ((.5 * polyW) + (.5 * m1W) + transActD);
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(actPin, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeLoRightActiveCon() {
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = bottomRIn.getX();
		double y = loLIn.getY() + ((.5 * polyW) + (.5 * m1W) + transActD);
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(actCon, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeHiLeftActiveCon() {
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = bottomLIn.getX();
		double y = hiLIn.getY() - ((.5 * polyW) + (.5 * m1W) + transActD);
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(actCon, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeTopMidActiveCon() {
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = bottomMIn.getX();
		double y = hiLIn.getY() + ((.5 * polyW) + (.5 * m1W) + transActD);
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(actCon, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeLoLeftActiveCon() {
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = bottomLIn.getX();
		double y = loLIn.getY() + ((.5 * polyW) + (.5 * m1W) + transActD);
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(actCon, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeMiddleBottomActiveCon() {
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = bottomMIn.getX();
		double y = loLIn.getY() - ((.5 * polyW) + (.5 * m1W) + transActD);
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(actCon, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeHiRightActiveCon() {
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = bottomRIn.getX();
		double y = hiLIn.getY() - ((.5 * polyW) + (.5 * m1W) + transActD);
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(actCon, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	/*
	 * private void correctLeftInputLo() { LayNode node =
	 * makeLowerLeftPolyPin(); makeArc(node, loLIn,m1Net); loLIn = node; }
	 */

	private LayNode makeLoRightPolyPin() {
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = bottomRIn.getX();
		double y = loLIn.getY();
		double width = polyW;
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(polyPin, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeHiRightPolyPin() {
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = bottomRIn.getX();
		double y = hiLIn.getY();
		double width = polyW;
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(polyPin, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeLoLeftPolyPin() {
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = bottomLIn.getX();
		double y = loLIn.getY();
		double width = polyW;
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(polyPin, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	/*
	 * private void correctLeftInputHi() { LayNode node =
	 * makeUpperLeftPolyPin(); makeArc(node, hiLIn,m1Net); hiLIn = node; }
	 */
	private LayNode makeHiLeftPolyPin() {
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = bottomLIn.getX();
		double y = hiLIn.getY();
		double width = polyW;
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(polyPin, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeLowLeftM1Pin() {
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = bottomLIn.getX();
		double y = loLIn.getY() - ((.5 * m1W) + (.5 * polyW) + transActD);
		double width = m1W;
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(m1Pin, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeLowMidM1Pin() {
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = bottomMIn.getX();
		double y = loLIn.getY() - ((.5 * m1W) + (.5 * polyW) + transActD);
		double width = m1W;
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(m1Pin, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeTopMidM1Pin() {
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = bottomMIn.getX();
		double y = hiLIn.getY() + ((.5 * m1W) + (.5 * polyW) + transActD);
		double width = m1W;
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(m1Pin, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeUpperLeftM1Pin() {
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = bottomLIn.getX();
		double y = hiLIn.getY() + ((.5 * m1W) + (.5 * polyW) + transActD);
		double width = m1W;
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(m1Pin, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeUpperRightM1Pin() {
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = bottomRIn.getX();
		double y = hiLIn.getY() + ((.5 * m1W) + (.5 * polyW) + transActD);
		double width = m1W;
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(m1Pin, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeMidLM1Pin() {
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = bottomLIn.getX();
		double y = loLIn.getY()
				+ ((.5 * m1W) + (.5 * polyW) + transActD + m1M1D);
		double width = m1W;
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(m1Pin, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeMidRM1Pin() {
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = bottomRIn.getX();
		double y = loLIn.getY()
				+ ((.5 * m1W) + (.5 * polyW) + transActD + m1M1D);
		double width = m1W;
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(m1Pin, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeLowRightM1Pin() {
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = bottomRIn.getX();
		double y = loLIn.getY() - ((.5 * m1W) + (.5 * polyW) + transActD);
		double width = m1W;
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(m1Pin, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	public LayNode getLeftHiOut() {
		return topLOut;
	}

	public LayNode getRightHiOut() {
		return topROut;
	}

	public LayNode getMidHiOut() {
		return topMOut;
	}

	public LayNode getUpperRightOut() {
		return hiROut;
	}

	public LayNode getLowerRightOut() {
		return loROut;
	}

	private void makeArc(LayNode startNode, LayNode endNode, String arcType) {
		String type = arcType;
		String name = "net@" + String.valueOf(numNets);
		netCount++;
		numNets++;
		String nameTD = "";
		double width = m1W;
		if (type.equals(polyNet)) {
			width = params.getPolyWidth();
		}
		else if (type.equals("N-Active")|| type.equals("P-Active")){
			width = params.getActiveWidth();
		}
		String flags = "S";

		LayArc arc = new LayArc(type, name, nameTD, width, flags, startNode,
				endNode, params);
		// arcs.add(arc);
		arcString += arc.getText();
	}

	/*
	 * public Vector getArcs() { return arcs; } public Vector getNodes() {
	 * return nodes; }
	 */
	private LayNode makeDummy() {
		String name = "";
		double x = 0;
		double y = 0;
		double width = 0;
		double height = 0;
		String orientation = "";
		LayNode node = new LayNode("", name, "", x, y, width, height,
				orientation, "");
		return node;
	}

	public LayNode getAltOutL() {
		return topLAltOut;
	}

	public LayNode getAltOutR() {
		return topRAltOut;
	}

	public int getNumNets() {
		return netCount;
	}

	public int getNumContacts() {
		return contactCount;
	}

	public int getNumPins() {
		return pinCount;
	}

	public int getNumNmos() {
		return nmosCount;
	}

	public int getNumPWells() {
		return pwellCount;
	}

	public String getNodeString() {
		return nodeString;
	}

	public String getArcString() {
		return arcString;
	}
}
