package plaGen;

import java.util.Vector;

public class OrPull {

	private Vector pwr;

	private Vector orPlane;

	private Vector gndLn;

	// private Vector layArcs;
	// private Vector layNodes;
	private String nodeString;

	private String arcString;

	private int numNets;

	private int netCount;

	private int numContacts;

	private int contactCount;

	private int numPins;

	private int pinCount;

	private int numPmos;

	private int pmosCount;

	private int numNWells;

	private int nwellCount;

	private Paramgetter params;

	public OrPull(Vector orPullPwr, Vector orPullOrPlane, Vector orPlaneGnd,
			Paramgetter p, int nets, int contacts, int pins, int pmos,
			int nwells) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPins = pins;
		pinCount = 0;
		numPmos = pmos;
		pmosCount = 0;
		numNWells = nwells;
		nwellCount = 0;

		pwr = orPullPwr;
		orPlane = orPullOrPlane;
		gndLn = orPlaneGnd;
		params = p;
		makeCells();
	}

	private void makeCells() {
		int numCells = gndLn.size();
		LayNode pwr1 = null;
		LayNode pwr2 = null;
		LayNode or1 = null;
		LayNode or2 = null;
		LayNode gnd = null;
		LayNode or3 = null;
		OrPullCell cell = null;
		LayNode link = null;

		for (int n = 0; n < numCells; n++) {
			pwr1 = (LayNode) pwr.get(2 * n);
			gnd = (LayNode) gndLn.get(n);
			or1 = (LayNode) orPlane.get(3 * n);
			or2 = (LayNode) orPlane.get((3 * n) + 1);

			if (n < (numCells - 1) || isEven(orPlane.size())) {
				or3 = (LayNode) orPlane.get((3 * n) + 2);
				pwr2 = (LayNode) pwr.get((2 * n) + 1);
				if (n > 0) {
					cell = new OrPullCell(gnd, pwr1, pwr2, or1, or2, or3,
							params, n, link, numNets, numContacts, numPins,
							numPmos, numNWells);
				} else {
					cell = new OrPullCell(gnd, pwr1, pwr2, or1, or2, or3,
							params, n, numNets, numContacts, numPins, numPmos,
							numNWells);
				}
				link = cell.getPrevLink();
			} else {
				cell = new OrPullCell(gnd, pwr1, or1, or2, params, n, link,
						numNets, numContacts, numPins, numPmos, numNWells);
			}
			// addArcs(cell.getArcs());
			// addNodes(cell.getNodes());
			nodeString += cell.getNodeString();
			arcString += cell.getArcString();

			numNets += cell.getNumNets();

			numContacts += cell.getNumContacts();

			numPmos += cell.getNumPmos();

			netCount += cell.getNumNets();

			contactCount += cell.getNumContacts();

			pmosCount += cell.getNumPmos();

		}
	}

	private boolean isEven(int n) {
		return (n % 3 == 0);
	}

	/*
	 * private void addArcs(Vector vA) { int numAdds = vA.size(); for (int n =
	 * 0; n < numAdds; n++) { arcs.add(vA.get(n)); } } private void
	 * addNodes(Vector vN) { int numAdds = vN.size(); for (int n = 0; n <
	 * numAdds; n++) { nodes.add(vN.get(n)); } } public Vector getNodes() {
	 * return nodes; } public Vector getArcs() { return arcs; }
	 */
	public int getNumNets() {
		return netCount;
	}

	public int getNumContacts() {
		return contactCount;
	}

	public int getNumPins() {
		return pinCount;
	}

	public int getNumPmos() {
		return pmosCount;
	}

	public int getNumNWells() {
		return nwellCount;
	}

	public String getNodeString() {
		return nodeString;
	}

	public String getArcString() {
		return arcString;
	}
}
