package plaGen;

public class OrPullCell {

	// private Vector layArcs;
	// private Vector layNodes;
	private String nodeString;

	private String arcString;

	private LayNode or1;

	private LayNode or2;

	private LayNode pwr1;

	private LayNode gnd;

	private LayNode linkPrev;

	private LayNode linkNext;

	private Paramgetter params;

	private int numNets;

	private int netCount;

	private int numContacts;

	private int contactCount;

	private int numPmos;

	private int pmosCount;

	private LayNode via;

	private LayNode or3;

	private LayNode pwr2;

	public OrPullCell(LayNode ground, LayNode p1, LayNode p2, LayNode a1,
			LayNode a2, LayNode a3, Paramgetter p, int n, int nets,
			int contacts, int pins, int pmos, int nwells) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPmos = pmos;
		pmosCount = 0;

		or1 = a1;
		or2 = a2;
		or3 = a3;
		pwr1 = p1;
		pwr2 = p2;
		gnd = ground;
		via = null;
		linkNext = null;
		params = p;
		makeHalf1a();
		makehalf2();
	}

	public OrPullCell(LayNode ground, LayNode p1, LayNode p2, LayNode a1,
			LayNode a2, LayNode a3, Paramgetter p, int n, LayNode prev,
			int nets, int contacts, int pins, int pmos, int nwells) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPmos = pmos;
		pmosCount = 0;

		or1 = a1;
		or2 = a2;
		or3 = a3;
		pwr1 = p1;
		pwr2 = p2;
		gnd = ground;
		linkNext = null;
		linkPrev = prev;
		via = null;
		params = p;

		makeHalf1();
		makehalf2();
	}

	public OrPullCell(LayNode ground, LayNode p1, LayNode a1, LayNode a2,
			Paramgetter p, int n, LayNode prev, int nets, int contacts,
			int pins, int pmos, int nwells) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPmos = pmos;
		pmosCount = 0;

		or1 = a1;
		or2 = a2;
		pwr1 = p1;
		gnd = ground;
		linkPrev = prev;
		params = p;

		via = null;
		makeHalf1();
	}

	private void makehalf2() {
		String m1 = "Metal-1";
		String poly = "Polysilicon-1";
		String pAct = "P-Active";

		LayNode actConHi = makeActConHi(pwr2);
		linkNext = makeWeakPmos(actConHi);
		LayNode actConLo = makeActConLo(linkNext);

		makeArc(pwr2, actConHi, m1);
		makeArc(actConHi, linkNext, pAct);
		makeArc(linkNext, actConLo, pAct);
		makeArc(actConLo, or3, m1);
		makeArc(via, linkNext, poly);
	}

	private void makeHalf1() {
		String m1 = "Metal-1";
		String poly = "Polysilicon-1";
		String pAct = "P-Active";
		String m2 = "Metal-2";

		LayNode actConHi = makeActConHi(pwr1);
		LayNode pmos = makeWeakPmos(actConHi);
		LayNode actConLo = makeActConLo(pmos);
		via = makeVia(pmos);
		LayNode outVia = makeOutVia(pmos);

		makeArc(pwr1, actConHi, m1);
		makeArc(actConHi, pmos, pAct);
		makeArc(pmos, actConLo, pAct);
		makeArc(actConLo, or1, m1);
		makeArc(pmos, via, poly);
		makeArc(via, or2, m1);
		makeArc(linkPrev, pmos, poly);
		makeArc(outVia, via, m1);
		makeArc(outVia, gnd, m2);
	}

	private void makeHalf1a() {
		String m1 = "Metal-1";
		String poly = "Polysilicon-1";
		String pAct = "P-Active";
		String m2 = "Metal-2";

		LayNode actConHi = makeActConHi(pwr1);
		LayNode pmos = makeWeakPmos(actConHi);
		LayNode actConLo = makeActConLo(pmos);
		via = makeVia(pmos);
		LayNode outVia = makeOutVia(pmos);

		makeArc(pwr1, actConHi, m1);
		makeArc(actConHi, pmos, pAct);
		makeArc(pmos, actConLo, pAct);
		makeArc(actConLo, or1, m1);
		makeArc(pmos, via, poly);
		makeArc(via, or2, m1);
		makeArc(outVia, via, m1);
		makeArc(outVia, gnd, m2);

	}

	private LayNode makeOutVia(LayNode pmos) {
		String type = "Metal-1-Metal-2-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double y = pmos.getY();
		double x = pmos.getX() + params.getPolyWidth()
				+ (params.getTransistorToActiveConnection() * 2)
				+ params.getM1Width();
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private void makeArc(LayNode head, LayNode tail, String aT) {
		String type = aT;
		String name = "net@" + String.valueOf(numNets);
		netCount++;
		numNets++;
		String nameTD = "";
		double width = params.getM1Width();
		if (type.equals("Polysilicon-1")) {
			width = params.getWeakPolyWidth();
		}
		else if (type.equals("N-Active")|| type.equals("P-Active")){
			width = params.getWeakActiveWidth();
		}
		String flags = "S";

		LayArc arc = new LayArc(type, name, nameTD, width, flags, head, tail,
				params);
		// arcs.add(arc);
		arcString += arc.getText();
	}

	private LayNode makeVia(LayNode pmos) {
		String type = "Metal-1-Polysilicon-1-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double y = pmos.getY();
		double x = pmos.getX() + params.getPolyWidth()
				+ (params.getTransistorToActiveConnection() * 2)
				+ params.getM1Width();
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private LayNode makeActConLo(LayNode pmos) {
		String type = "Metal-1-P-Active-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double width = params.getM1Width();
		double height = width;
		double y = pmos.getY()
				- ((.5 * params.getM1Width())
						+ (.5 * params.getWeakPolyWidth()) + params
						.getWeakTransistorToActiveConnection());
		double x = pmos.getX();
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private LayNode makeWeakPmos(LayNode con) {
		String type = "P-Transistor";
		String name = "pmos@" + String.valueOf(numPmos);
		pmosCount++;
		numPmos++;
		double width = params.getWeakPmosSize();
		double height = params.getWeakPolyWidth();
		double y = con.getY()
				- (((.5 * params.getM1Width())
						+ (.5 * params.getWeakPolyWidth()) + params
						.getWeakTransistorToActiveConnection()));
		double x = con.getX();
		String orientation = "";
		String flags = "V";
		String vars = "SIM_weak_node(D5G1;)SWeak";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, flags, vars);
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private LayNode makeActConHi(LayNode pwr) {
		String type = "Metal-1-P-Active-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double width = params.getM1Width();
		double height = width;
		double x = pwr.getX();
		double y = pwr.getY()
				- (params.getM1Width()+4);
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	public LayNode getPrevLink() {
		return linkNext;
	}

	/*
	 * public Vector getArcs() { return arcs; } public Vector getNodes() {
	 * return nodes; }
	 */
	public int getNumNets() {
		return netCount;
	}

	public int getNumContacts() {
		return contactCount;
	}

	public int getNumPmos() {
		return pmosCount;
	}

	public String getNodeString() {
		return nodeString;
	}

	public String getArcString() {
		return arcString;
	}
}
