package plaGen;

import java.util.Vector;

public class OutInv {

	private Vector pwrNodes;

	private Vector expNodes;

	private Vector orNodes;

	// private Vector layArcs;
	// private Vector layNodes;
	private String nodeString;

	private String arcString;

	private Paramgetter params;

	private int numNets;

	private int netCount;

	private int numContacts;

	private int contactCount;

	private int numPins;

	private int pinCount;

	private int numNmos;

	private int nmosCount;

	private int numPmos;

	private int pmosCount;

	public OutInv(Vector outInvPwr, Vector orOutInv, Vector outInvOutExp,
			Paramgetter p, int nets, int contacts, int pins, int pmos, int nmos) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPins = pins;
		pinCount = 0;
		numNmos = nmos;
		nmosCount = 0;
		numPmos = pmos;
		pmosCount = 0;

		pwrNodes = outInvPwr;
		expNodes = outInvOutExp;
		orNodes = orOutInv;
		params = p;
		makeCells();
	}

	private void makeCells() {
		int orSize = orNodes.size();
		LayNode or1 = null;
		LayNode or2 = null;
		LayNode or3 = null;
		LayNode exp1 = null;
		LayNode exp2 = null;
		LayNode pwr = null;
		OutInvCell cell = null;
		for (int n = 0; n < pwrNodes.size(); n++) {
			or1 = (LayNode) orNodes.get(3 * n);
			or2 = (LayNode) orNodes.get((3 * n) + 1);
			exp1 = (LayNode) expNodes.get(2 * n);
			pwr = (LayNode) pwrNodes.get(n);
			if (n < (pwrNodes.size() - 1) || isEven(orSize)) {
				or3 = (LayNode) orNodes.get((3 * n) + 2);
				exp2 = (LayNode) expNodes.get((2 * n) + 1);
				cell = new OutInvCell(or1, or2, or3, exp1, exp2, pwr, params,
						n, numNets, numContacts, numPins, numPmos, numNmos);
			} else {
				cell = new OutInvCell(or1, or2, exp1, pwr, params, n, numNets,
						numContacts, numPins, numPmos, numNmos);
			}
			// addArcs(cell.getArcs());
			// addNodes(cell.getNodes());
			nodeString += cell.getNodeString();
			arcString += cell.getArcString();

			numNets += cell.getNumNets();

			numContacts += cell.getNumContacts();

			numPins += cell.getNumPins();

			numNmos += cell.getNumNmos();

			numPmos += cell.getNumPmos();

			netCount += cell.getNumNets();

			contactCount += cell.getNumContacts();

			pinCount += cell.getNumPins();

			nmosCount += cell.getNumNmos();

			pmosCount += cell.getNumPmos();
		}
	}

	private boolean isEven(int n) {
		return (n % 3 == 0);
	}

	/*
	 * private void addArcs(Vector vA) { int numAdds = vA.size(); for (int n =
	 * 0; n < numAdds; n++) { arcs.add(vA.get(n)); } } private void
	 * addNodes(Vector vN) { int numAdds = vN.size(); for (int n = 0; n <
	 * numAdds; n++) { nodes.add(vN.get(n)); } } public Vector getNodes() {
	 * return nodes; } public Vector getArcs() { return arcs; }
	 */
	public int getNumNets() {
		return netCount;
	}

	public int getNumContacts() {
		return contactCount;
	}

	public int getNumPins() {
		return pinCount;
	}

	public int getNumPmos() {
		return pmosCount;
	}

	public int getNumNmos() {
		return nmosCount;
	}

	public String getNodeString() {
		return nodeString;
	}

	public String getArcString() {
		return arcString;
	}

}
