package plaGen;

public class OutInvCell {

	// private Vector layArcs;
	// private Vector layNodes;
	private String nodeString;

	private String arcString;

	private LayNode or1;

	private LayNode or2;

	private LayNode exp1;

	private LayNode pwr;

	private LayNode nmosCon;

	private LayNode pmosCon;

	private int numNets;

	private int netCount;

	private int numContacts;

	private int contactCount;

	private int numPins;

	private int pinCount;

	private int numNmos;

	private int nmosCount;

	private int numPmos;

	private int pmosCount;

	private Paramgetter params;

	public OutInvCell(LayNode o1, LayNode o2, LayNode e1, LayNode power,
			Paramgetter p, int c, int nets, int contacts, int pins, int pmos,
			int nmos) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPins = pins;
		pinCount = 0;
		numNmos = nmos;
		nmosCount = 0;
		numPmos = pmos;
		pmosCount = 0;

		or1 = o1;
		or2 = o2;
		exp1 = e1;
		pwr = power;
		params = p;

		nmosCon = null;
		pmosCon = null;

		makeHalf();
	}

	private LayNode or3;

	private LayNode exp2;

	public OutInvCell(LayNode o1, LayNode o2, LayNode o3, LayNode e1,
			LayNode e2, LayNode power, Paramgetter p, int c, int nets,
			int contacts, int pins, int pmos, int nmos) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numContacts = contacts;
		contactCount = 0;
		numPins = pins;
		pinCount = 0;
		numNmos = nmos;
		nmosCount = 0;
		numPmos = pmos;
		pmosCount = 0;

		or1 = o1;
		or2 = o2;
		or3 = o3;
		exp1 = e1;
		exp2 = e2;
		pwr = power;
		params = p;

		nmosCon = null;
		pmosCon = null;

		makeHalf();
		makeRest();
	}

	private void makeRest() {
		LayNode m1PolyViaR = makeM1PolyViaR();
		LayNode polyPinR = makePolyPinR();
		LayNode nmosR = makeNmosR();
		LayNode nmosActiveR = makeNmosActR();
		LayNode pmosActiveR = makePmosActR();
		LayNode pmosR = makePmosR();

		String m1 = "Metal-1";
		String poly = "Polysilicon-1";
		String nAct = "N-Active";
		String pAct = "P-Active";

		makeArc(or3, m1PolyViaR, m1);
		makeArc(m1PolyViaR, polyPinR, poly);
		makeArc(polyPinR, nmosR, poly);
		makeArc(nmosR, nmosActiveR, nAct);
		makeArc(nmosR, nmosCon, nAct);
		makeArc(nmosActiveR, exp2, m1);
		makeArc(exp2, pmosActiveR, m1);
		makeArc(pmosActiveR, pmosR, pAct);
		makeArc(pmosR, pmosCon, pAct);
		makeArc(nmosR, pmosR, poly);
	}

	private LayNode makePmosR() {
		String type = "P-Transistor";
		String name = "pmos@" + String.valueOf(numPmos);
		pmosCount++;
		numPmos++;
		double width = 2 * params.getNMosInvWidth();
		double height = params.getPolyWidth();
		double x = exp2.getX()
				- ((.5 * params.getM1Width()) + (.5 * params.getPolyWidth()) + params
						.getTransistorToActiveConnection());
		double y = pwr.getY()
				+ ((.5 * params.getPowerAndGndWide()) + params.getM1ToM1() + (.5 * width));
		String orientation = "R";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private LayNode makePmosActR() {
		String type = "Metal-1-P-Active-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double width = params.getM1Width();
		double height = 2 * params.getNMosInvWidth();
		double x = exp2.getX();
		double y = pwr.getY()
				+ ((.5 * params.getPowerAndGndWide()) + params.getM1ToM1() + (.5 * height));
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private LayNode makeNmosActR() {
		String type = "Metal-1-N-Active-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double width = params.getM1Width();
		double height = params.getNMosInvWidth();
		double x = exp2.getX();
		double y = or3.getY()
				- ((.5 * params.getPowerAndGndWide()) + params.getM1ToM1() + (.5 * height));
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private LayNode makeNmosR() {
		String type = "N-Transistor";
		String name = "nmos@" + String.valueOf(numNmos);
		nmosCount++;
		numNmos++;
		double width = params.getNMosInvWidth();
		double height = params.getPolyWidth();
		double x = exp2.getX()
				- ((.5 * params.getM1Width()) + (.5 * params.getPolyWidth()) + params
						.getTransistorToActiveConnection());
		double y = or3.getY()
				- ((.5 * params.getPowerAndGndWide()) + params.getM1ToM1() + (.5 * width));
		String orientation = "R";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private LayNode makePolyPinR() {
		String type = "Polysilicon-1-Pin";
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = or3.getX()
				- ((.5 * params.getM1Width()) + (.5 * params.getPolyWidth()) + params
						.getTransistorToActiveConnection());
		double y = or3.getY();
		double width = params.getPolyWidth();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private LayNode makeM1PolyViaR() {
		String type = "Metal-1-Polysilicon-1-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = or3.getX() - params.getTransistorToActiveConnection();
		double y = or3.getY();
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private void makeArc(LayNode head, LayNode tail, String aT) {
		String type = aT;
		String name = "net@" + String.valueOf(numNets);
		netCount++;
		numNets++;
		String nameTD = "";
		double width = params.getM1Width();
		if (type.equals("Polysilicon-1")) {
			width = params.getPolyWidth();
		}
		else if (type.equals("N-Active")|| type.equals("P-Active")){
			width = params.getActiveWidth();
		}
		String flags = "S";

		LayArc arc = new LayArc(type, name, nameTD, width, flags, head, tail,
				params);
		// arcs.add(arc);
		arcString += arc.getText();
	}

	private void makeHalf() {
		LayNode m1PolyViaL = makeM1PolyViaL();
		LayNode polyPinL = makePolyPinL();
		LayNode nmosL = makeNmosL();
		LayNode nmosActiveL = makeNmosActL();
		nmosCon = makeNmosActM();
		LayNode pmosActiveL = makePmosActL();
		pmosCon = makePmosActM();
		LayNode pmosL = makePmosL();

		String m1 = "Metal-1";
		String poly = "Polysilicon-1";
		String nAct = "N-Active";
		String pAct = "P-Active";

		makeArc(or1, m1PolyViaL, m1);
		makeArc(m1PolyViaL, polyPinL, poly);
		makeArc(nmosL, polyPinL, poly);
		makeArc(nmosActiveL, nmosL, nAct);
		makeArc(nmosL, nmosCon, nAct);
		makeArc(nmosActiveL, exp1, m1);
		makeArc(exp1, pmosActiveL, m1);
		makeArc(pmosActiveL, pmosL, pAct);
		makeArc(pmosL, pmosCon, pAct);
		makeArc(nmosL, pmosL, poly);
		makeArc(pwr, pmosCon, m1);
		makeArc(nmosCon, or2, m1);

	}

	private LayNode makePmosL() {
		String type = "P-Transistor";
		String name = "pmos@" + String.valueOf(numPmos);
		pmosCount++;
		numPmos++;
		double width = 2 * params.getNMosInvWidth();
		double height = params.getPolyWidth();
		double x = exp1.getX()
				+ ((.5 * params.getM1Width()) + (.5 * params.getPolyWidth()) + params
						.getTransistorToActiveConnection());
		double y = pwr.getY()
				+ ((.5 * params.getPowerAndGndWide()) + params.getM1ToM1() + (.5 * width));
		String orientation = "R";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private LayNode makePmosActM() {
		String type = "Metal-1-P-Active-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double width = params.getM1Width();
		double height = 2 * params.getNMosInvWidth();
		double x = exp1.getX() + params.getM1Width() + params.getPolyWidth()
				+ (2 * params.getTransistorToActiveConnection());
		double y = pwr.getY()
				+ ((.5 * params.getPowerAndGndWide()) + params.getM1ToM1() + (.5 * height));
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private LayNode makePmosActL() {
		String type = "Metal-1-P-Active-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double width = params.getM1Width();
		double height = 2 * params.getNMosInvWidth();
		double x = exp1.getX();
		double y = pwr.getY()
				+ ((.5 * params.getPowerAndGndWide()) + params.getM1ToM1() + (.5 * height));
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private LayNode makeNmosActM() {
		String type = "Metal-1-N-Active-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double width = params.getM1Width();
		double height = params.getNMosInvWidth();
		double x = exp1.getX() + params.getM1Width() + params.getPolyWidth()
				+ (2 * params.getTransistorToActiveConnection());
		double y = or1.getY()
				- ((.5 * params.getPowerAndGndWide()) + params.getM1ToM1() + (.5 * height));
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private LayNode makeNmosActL() {
		String type = "Metal-1-N-Active-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double width = params.getM1Width();
		double height = params.getNMosInvWidth();
		double x = exp1.getX();
		double y = or1.getY()
				- ((.5 * params.getPowerAndGndWide()) + params.getM1ToM1() + (.5 * height));
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private LayNode makeNmosL() {
		String type = "N-Transistor";
		String name = "nmos@" + String.valueOf(numNmos);
		nmosCount++;
		numNmos++;
		double width = params.getNMosInvWidth();
		double height = params.getPolyWidth();
		double x = exp1.getX()
				+ ((.5 * params.getM1Width()) + (.5 * params.getPolyWidth()) + params
						.getTransistorToActiveConnection());
		double y = or1.getY()
				- ((.5 * params.getPowerAndGndWide()) + params.getM1ToM1() + (.5 * width));
		String orientation = "R";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private LayNode makePolyPinL() {
		String type = "Polysilicon-1-Pin";
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double x = or1.getX()
				+ ((.5 * params.getM1Width()) + (.5 * params.getPolyWidth()) + params
						.getTransistorToActiveConnection());
		double y = or1.getY();
		double width = params.getPolyWidth();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private LayNode makeM1PolyViaL() {
		String type = "Metal-1-Polysilicon-1-Con";
		String name = "contact@" + String.valueOf(numContacts);
		contactCount++;
		numContacts++;
		double x = or1.getX() + params.getTransistorToActiveConnection();
		double y = or1.getY();
		double width = params.getM1Width();
		double height = width;
		String orientation = "";

		LayNode node = new LayNode(type, name, "", x, y, width, height,
				orientation, "");
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	/*
	 * public Vector getArcs() { return arcs; } public Vector getNodes() {
	 * return nodes; }
	 */
	public int getNumNets() {
		return netCount;
	}

	public int getNumContacts() {
		return contactCount;
	}

	public int getNumPins() {
		return pinCount;
	}

	public int getNumPmos() {
		return pmosCount;
	}

	public int getNumNmos() {
		return nmosCount;
	}

	public String getNodeString() {
		return nodeString;
	}

	public String getArcString() {
		return arcString;
	}
}
