package plaGen;

import java.util.Vector;

public class Pwr {

	private Vector outInv;

	private Vector inInv;

	private Vector andPull;

	private Vector orPull;

	private Vector exp;

	// private Vector layArcs;
	// private Vector layNodes;
	private String nodeString;

	private String arcString;

	private Vector outputs;

	private Paramgetter params;

	private LayNode hiPin;

	private int numNets;

	private int netCount;

	private int numPins;

	private int pinCount;

	private int numNWells;

	private int nwellCount;

	public Pwr(Vector orPullPwr, Vector andPullPwr, Vector inInvPwr,
			Vector outInvPwr, Vector pwrPwrExp, Paramgetter p, int nets,
			int pins, int nwells, Vector outInvOutExp) {
		hiPin = null;
		outInv = outInvPwr;
		inInv = inInvPwr;
		andPull = andPullPwr;
		orPull = orPullPwr;
		exp = pwrPwrExp;
		outputs = outInvOutExp;

		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numPins = pins;
		pinCount = 0;
		numNWells = nwells;
		nwellCount = 0;

		params = p;
		makePwr();
	}

	private void makePwr() {
		makeHiPin();
		makeTopLine();
		makeSideLine();
		makeLowLLine();
		makeLowRLine();
	}

	private void makeHiPin() {
		String type = "Metal-1-Pin";
		double mW = params.getPowerAndGndWide();
		String name = "pin@" + String.valueOf(numPins);
		pinCount++;
		numPins++;
		double xVal = ((LayNode) exp.get(0)).getX();
		double yVal = ((LayNode) orPull.get(0)).getY();
		String flags = "V";
		hiPin = new LayNode(type, name, "", xVal, yVal, mW, mW, "", flags);
		//nodes.add(hiPin);
		nodeString+=hiPin.getText();
	}

	private void makeTopLine() {
		int numSegments = orPull.size();
		boolean endFlag = false;
		LayNode startNode = null;
		LayNode endNode = null;
		for (int n = 0; n < numSegments; n++) {
			startNode = null;
			endNode = (LayNode) orPull.get(n);
			if (n > 0) {
				startNode = (LayNode) orPull.get(n - 1);
			} else {
				startNode = hiPin;
			}
			PwrHorTCell cell = new PwrHorTCell(startNode, endNode, params, n,
					endFlag, numNets, numPins, numNWells);
			// addArcs(cell.getArcs());
			// addNodes(cell.getNodes());
			nodeString += cell.getNodeString();
			arcString += cell.getArcString();

			numNets += cell.getNumNets();

			numPins += cell.getNumPins();

			numNWells += cell.getNumNWells();

			netCount += cell.getNumNets();

			pinCount += cell.getNumPins();

			nwellCount += cell.getNumNWells();

			if (((numSegments % 2) != 0) && (n == numSegments - 1)) {
				endFlag = true;
				n++;
				cell = new PwrHorTCell(endNode, endNode, params, n, endFlag,
						numNets, numPins, numNWells);
				// addArcs(cell.getArcs());
				// addNodes(cell.getNodes());
				nodeString += cell.getNodeString();
				arcString += cell.getArcString();

				numNets += cell.getNumNets();

				numPins += cell.getNumPins();

				numNWells += cell.getNumNWells();

				netCount += cell.getNumNets();

				pinCount += cell.getNumPins();

				nwellCount += cell.getNumNWells();
			}
		}
	}

	private void makeSideLine() {
		int numSegments = andPull.size() + 1;
		boolean endFlag = false;
		boolean oddFlag = false;
		if (numSegments % 2 != 0) {
			oddFlag = true;
		}
		LayNode startNode = null;
		LayNode endNode = null;
		for (int n = 0; n < numSegments - 1; n++) {
			if (n != 0) {
				startNode = (LayNode) andPull.get(n - 1);
			} else {
				startNode = (LayNode) exp.get(0);
			}
			endNode = (LayNode) andPull.get(n);
			PwrSideCell cell = new PwrSideCell(startNode, endNode, params, n,
					endFlag, oddFlag, numNets, numPins, numNWells);
			// addArcs(cell.getArcs());
			// addNodes(cell.getNodes());
			nodeString += cell.getNodeString();
			arcString += cell.getArcString();

			numNets += cell.getNumNets();

			numNWells += cell.getNumNWells();

			netCount += cell.getNumNets();

			nwellCount += cell.getNumNWells();

			if (n == numSegments - 2) {
				n++;
				endFlag = true;
				startNode = endNode;
				endNode = hiPin;
				cell = new PwrSideCell(startNode, endNode, params, n, endFlag,
						oddFlag, numNets, numPins, numNWells);
				// addArcs(cell.getArcs());
				// addNodes(cell.getNodes());
				nodeString += cell.getNodeString();
				arcString += cell.getArcString();

				numNets += cell.getNumNets();

				numNWells += cell.getNumNWells();

				netCount += cell.getNumNets();

				nwellCount += cell.getNumNWells();
			}
		}
	}

	private void makeLowLLine() {
		int numSegments = inInv.size();
		LayNode startNode = null;
		LayNode endNode = null;
		for (int n = 0; n < numSegments + 1; n++) {

			if (n != numSegments) {
				endNode = (LayNode) inInv.get(n);
			} else {
				endNode = (LayNode) outInv.get(0);
			}
			if (n > 0) {
				startNode = (LayNode) inInv.get(n - 1);
			} else {
				startNode = (LayNode) exp.get(0);
			}
			PwrHorLLCell cell = new PwrHorLLCell(startNode, endNode, params, n,
					numNets, numPins, numNWells);
			// addArcs(cell.getArcs());
			// addNodes(cell.getNodes());
			nodeString += cell.getNodeString();
			arcString += cell.getArcString();

			numNets += cell.getNumNets();

			numNWells += cell.getNumNWells();

			netCount += cell.getNumNets();

			nwellCount += cell.getNumNWells();
		}
	}

	private void makeLowRLine() {
		int numOuts = outputs.size();
		int numSegments = outInv.size();
		boolean endFlag = false;
		boolean oddFlag = false;
		if (numOuts % 2 != 0) {
			oddFlag = true;
		}
		LayNode startNode = null;
		LayNode endNode = null;
		for (int n = 0; n < numSegments - 1; n++) {
			startNode = (LayNode) outInv.get(n);
			endNode = (LayNode) outInv.get(n + 1);
			PwrHorLRCell cell = new PwrHorLRCell(startNode, endNode, params, n,
					endFlag, oddFlag, numNets, numPins, numNWells);
			// addArcs(cell.getArcs());
			// addNodes(cell.getNodes());
			nodeString += cell.getNodeString();
			arcString += cell.getArcString();

			numNets += cell.getNumNets();

			numNWells += cell.getNumNWells();

			netCount += cell.getNumNets();

			nwellCount += cell.getNumNWells();

			if (n == (numSegments - 2)) {
				n++;
				endFlag = true;
				cell = new PwrHorLRCell(endNode, endNode, params, n, endFlag,
						oddFlag, numNets, numPins, numNWells);
				// addArcs(cell.getArcs());
				// addNodes(cell.getNodes());
				nodeString += cell.getNodeString();
				arcString += cell.getArcString();

				numNets += cell.getNumNets();

				numNWells += cell.getNumNWells();

				netCount += cell.getNumNets();

				nwellCount += cell.getNumNWells();
			}
		}
	}

	/*
	 * public Vector getNodes() { return nodes; } public Vector getArcs() {
	 * return arcs; } private void addArcs(Vector aV) { int numAdds = aV.size();
	 * for (int n = 0; n < numAdds; n++) { arcs.add(aV.get(n)); } } private void
	 * addNodes(Vector nV) { int numAdds = nV.size(); for (int n = 0; n <
	 * numAdds; n++) { nodes.add(nV.get(n)); } }
	 */
	public int getNumNets() {
		return netCount;
	}

	public int getNumPins() {
		return pinCount;
	}

	public int getNumNWells() {
		return nwellCount;
	}

	public String getNodeString() {
		return nodeString;
	}

	public String getArcString() {
		return arcString;
	}

}
