package plaGen;

public class PwrHorLLCell {
	// private Vector layArcs;
	// private Vector layNodes;
	private String nodeString;

	private String arcString;

	private LayNode head;

	private LayNode tail;

	private Paramgetter params;

	private int counter;

	private int numNets;

	private int netCount;

	private int numNWells;

	private int nwellCount;

	public PwrHorLLCell(LayNode startNode, LayNode endNode, Paramgetter p,
			int n, int nets, int pins, int nwells) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numNWells = nwells;
		nwellCount = 0;

		head = startNode;
		tail = endNode;
		counter = n;
		params = p;
		makeCell();
	}

	private void makeCell() {
		if (counter > 0) {
			LayNode well1 = makeWell1();
			LayNode well2 = makeWell2();
			makeArc(head, well1);
			makeArc(well1, well2);
			makeArc(well2, tail);
		} else {
			makeArc(head, tail);
		}
	}

	private LayNode makeWell1() {
		String type = "Metal-1-N-Well-Con";
		String name = "substr@" + String.valueOf(numNWells);
		nwellCount++;
		numNWells++;
		String nameTD = "";
		double x = head.getX();
		double y = head.getY();
		double w = params.getM1Width();
		double h = w;
		String orientation = "";
		String flag = "V";
		LayNode node = new LayNode(type, name, nameTD, x, y, w, h, orientation,
				flag);
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private LayNode makeWell2() {
		String type = "Metal-1-N-Well-Con";
		String name = "substr@" + String.valueOf(numNWells);
		nwellCount++;
		numNWells++;
		String nameTD = "";
		double x = head.getX() + params.getM1Width()
				+ (2 * params.getTransistorToActiveConnection())
				+ params.getPolyWidth();
		double y = head.getY();
		double w = params.getM1Width();
		double h = w;
		String orientation = "";
		String flag = "V";
		LayNode node = new LayNode(type, name, nameTD, x, y, w, h, orientation,
				flag);
		// nodes.add(node);
		nodeString += node.getText();
		return node;
	}

	private void makeArc(LayNode h, LayNode t) {
		String type = "Metal-1";
		String name = "net@" + String.valueOf(numNets);
		netCount++;
		numNets++;
		String nameTD = "";
		double width = params.getPowerAndGndWide();
		String flags = "S";
		LayArc arc = new LayArc(type, name, nameTD, width, flags, h, t, params);
		// arcs.add(arc);
		arcString += arc.getText();
	}

	/*
	 * public Vector getArcs() { return arcs; } public Vector getNodes() {
	 * return nodes; }
	 */
	public int getNumNets() {
		return netCount;
	}

	public int getNumNWells() {
		return nwellCount;
	}

	public String getNodeString() {
		return nodeString;
	}

	public String getArcString() {
		return arcString;
	}
}
