package plaGen;

public class PwrSideCell {

	// private Vector layArcs;
	// private Vector layNodes;
	private String nodeString;

	private String arcString;

	private LayNode head;

	private LayNode tail;

	private Paramgetter params;

	private int count;

	private boolean endFlag;

	private int numNets;

	private int netCount;

	private int numNWells;

	private int nwellCount;

	public PwrSideCell(LayNode startNode, LayNode endNode, Paramgetter p,
			int n, boolean f1, boolean f2, int nets, int pins, int nwells) {
		// nodes = new Vector(10,10);
		// arcs = new Vector(10,10);
		nodeString = "";
		arcString = "";

		numNets = nets;
		netCount = 0;
		numNWells = nwells;
		nwellCount = 0;

		head = startNode;
		tail = endNode;
		count = n;
		endFlag = f1;
		params = p;

		makeCell();
	}

	private void makeCell() {
		if (((count % 2) == 0) || endFlag) {
			makeArc(head, tail);
			if ((count % 2) != 0) {
				LayNode well1 = makeWell1();
				LayNode well2 = makeWell1();
				makeArc(well1, well2);
				makeArc(well1, head);
			}
		} else {
			LayNode well1 = makeWell1();
			LayNode well2 = makeWell2();
			LayNode well3 = makeWell3();
			makeArc(head, well1);
			makeArc(well1, well2);
			makeArc(well2, well3);
			makeArc(well3, tail);
		}
	}

	private LayNode makeWell3() {
		String type = "Metal-1-N-Well-Con";
		String name = "substr@" + String.valueOf(numNWells);
		nwellCount++;
		numNWells++;
		String nameTD = "";
		double x = tail.getX();
		double y = tail.getY();
		double w = params.getM1Width();
		double h = w;
		String orientation = "";
		String flag = "V";
		LayNode node = new LayNode(type, name, nameTD, x, y, w, h, orientation,
				flag);
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private LayNode makeWell2() {
		String type = "Metal-1-N-Well-Con";
		String name = "substr@" + String.valueOf(numNWells);
		nwellCount++;
		numNWells++;
		String nameTD = "";
		double x = head.getX();
		double y = head.getY() + params.getM1ToM1() + params.getM1Width();
		double w = params.getM1Width();
		double h = w;
		String orientation = "";
		String flag = "V";
		LayNode node = new LayNode(type, name, nameTD, x, y, w, h, orientation,
				flag);
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	private LayNode makeWell1() {
		String type = "Metal-1-N-Well-Con";
		String name = "substr@" + String.valueOf(numNWells);
		nwellCount++;
		numNWells++;
		String nameTD = "";
		double x = head.getX();
		double y = head.getY();
		double w = params.getM1Width();
		double h = w;
		String orientation = "";
		String flag = "V";
		LayNode node = new LayNode(type, name, nameTD, x, y, w, h, orientation,
				flag);
		// nodes.add(node);
		nodeString += node.getText();

		return node;
	}

	/*
	 * public Vector getArcs() { return arcs; } public Vector getNodes() {
	 * return nodes; }
	 */
	private void makeArc(LayNode h, LayNode t) {
		String type = "Metal-1";
		String name = "net@" + String.valueOf(numNets);
		netCount++;
		numNets++;
		String nameTD = "";
		double width = params.getPowerAndGndWide();
		String flags = "S";
		LayArc arc = new LayArc(type, name, nameTD, width, flags, h, t, params);
		// arcs.add(arc);
		arcString += arc.getText();

	}

	public int getNumNets() {
		return netCount;
	}

	public int getNumNWells() {
		return nwellCount;
	}

	public String getNodeString() {
		return nodeString;
	}

	public String getArcString() {
		return arcString;
	}
}
