package plaGen;

public class SchNode

{

	public static final int NT_pmos = 0;

	public static final int NT_nmos = 1;

	public static final int NT_pin = 2;

	public static final int NT_power = 3;

	public static final int NT_ground = 4;

	public static final int NT_pmosi = 5;

	public static final String S_nmos = "nmos";

	public static final String S_pmos = "pmos";

	public static final String S_pin = "pin";

	public static final String S_power = "pwr";

	public static final String S_ground = "gnd";

	protected int iType;

	protected String sType;

	protected String sName;

	protected float flX;

	protected float flY;

	protected float flWidth;

	protected float flLength;

	protected float flRot;

	protected int iTType = -1;

	protected SchematicManager lib;

	SchNode(int type, float x, float y, float w, float l, float rotation,
			String name, SchematicManager lib)

	{

		this.lib = lib;

		this.iType = type;

		this.flX = x;

		this.flY = y;

		this.flWidth = w;

		this.flLength = l;

		this.sName = name;

		this.flRot = rotation;

		switch (iType) {

		case NT_pmos:
			sType = "Transistor";
			break;

		case NT_pmosi:
			sType = "Transistor";
			break;

		case NT_nmos:
			sType = "Transistor";
			break;

		case NT_pin:
			sType = "Wire_Pin";
			break;

		case NT_power:
			sType = "Power";
			break;

		case NT_ground:
			sType = "Ground";
			break;

		}

	}

	public String GetString()

	{

		String flags = "";

		if ((iType == NT_pmos) || (iType == NT_pmosi))

		{

			flags = "2";

		}

		String disp = "";

		String rot = "";

		if ((iType == NT_pmosi) || (iType == NT_nmos)) {

			disp = "ATTR_length(D5G0.5;X-0.5;Y-1;)D" + flLength
					+ "|ATTR_width(D5G1;X0.5;Y-1;)D" + flWidth;

			rot = flRot + "|";

		}

		if ((iType == NT_pmos))

		{

			disp = "ATTR_length(D5G0.5;X-0.5;Y-1;)D" + flLength
					+ "|ATTR_width(D5G1;X0.5;Y-1;)D" + flWidth
					+ "|SIM_weak_node(D5G1;)SWeak";

			rot = flRot + "|";

		}

		if (iType == NT_pin)

		{

			return "N" + sType + "|" + sName + "||" + flX + "|" + flY + "|"
					+ flWidth + "|" + flLength + "|" + rot + flags + "|" + disp;

		}

		else

		{

			return "N" + sType + "|" + sName + "||" + flX + "|" + flY + "|4|4|"
					+ rot + flags + "|" + disp;

		}

	}

	public float px(String p)

	{

		if (p.equals("")) {

			return flX;

		}

		else if (p.equals("g")) {

			switch ((int) flRot) {

			case 0:
				return flX;

			case 900:
				return flX - 1;

			default:
				return -1;

			}

		}

		else if (p.equals("d")) {

			switch ((int) flRot) {

			case 0:
				return flX + 2;

			case 900:
				return flX + 2;

			default:
				return -1;

			}

		}

		else if (p.equals("s")) {

			switch ((int) flRot) {

			case 0:
				return flX - 2;

			case 900:
				return flX + 2;

			default:
				return -1;

			}

		}

		else if (p.equals("gnd")) {

			switch ((int) flRot) {

			case 0:
				return flX;

			case 900:
				return flX;

			default:
				return -1;

			}

		}

		return flX;

	}

	public float py(String p)

	{

		if (p.equals("")) {

			return flY;

		}

		else if (p.equals("g")) {

			switch ((int) flRot) {

			case 0:
				return flY + 1;

			case 900:
				return flY;

			default:
				return -1;

			}

		}

		else if (p.equals("d")) {

			switch ((int) flRot) {

			case 0:
				return flY - 2;

			case 900:
				return flY + 2;

			default:
				return -1;

			}

		}

		else if (p.equals("s")) {

			switch ((int) flRot) {

			case 0:
				return flY - 2;

			case 900:
				return flY - 2;

			default:
				return -1;

			}

		}

		else if (p.equals("gnd")) {

			switch ((int) flRot) {

			case 0:
				return flY + 2;

			case 900:
				return flY + 2;

			default:
				return -1;

			}

		}

		return flY;

	}

	public float dx()

	{

		return flX + 2;

	}

	public float dy()

	{

		return flY + 2;

	}

	public float sx()

	{

		return flX + 2;

	}

	public float sy()

	{

		return flY - 2;

	}

	public float gx()

	{

		return flX - 1;

	}

	public float gy()

	{

		return flY;

	}

	public float x()

	{

		return flX;

	}

	public float y()

	{

		return flY;

	}

}