package plaGen;

import java.util.Vector;

public class SchematicCell

{

	SchematicManager lib;

	public SchematicCell(Caseinfo cinfo, Paramgetter pget)

	{

		int[][] Aplane = cinfo.getInputMatrix();

		int[][] Oplane = cinfo.getOutputMatrix();

		String inputBus = cinfo.getInBusName();

		String outputBus = cinfo.getOutBusName();

		int numInputBits = cinfo.getNumInputBits();

		int numOutputBits = cinfo.getNumOutputBits();

		int numTerms = cinfo.getNumCases();

		String cellName = pget.getCellName();

		lib = new SchematicManager(cellName + "_Cell");

		String[] InvPair = lib.CreateInputInverters(0, 0, inputBus,
				numInputBits);

		Vector ANDplane = lib.CreateANDPlane(-1, 16, Aplane, numInputBits,
				numTerms);

		lib.WireANDtoInv(ANDplane, InvPair);

		float orpx = lib.nx(InvPair[InvPair.length - 1], "d") + 12;

		Vector ORplane = lib.CreateORPlane(orpx, 13, Oplane, numOutputBits,
				numTerms);

		lib.WireORtoAND(ORplane, ANDplane);

		String[] ORout = (String[]) ORplane
				.elementAt(SchematicManager.ORPLANE_output);

		float outinvx = lib.nx(ORout[0], "d");

		float outinvy = -3;

		String[] OutInv = lib.CreateOutputInverters(outinvx, outinvy,
				outputBus, numOutputBits);

		lib.WireORtoInv(ORplane, OutInv);

		String[] ANDout = (String[]) ANDplane
				.elementAt(SchematicManager.ANDPLANE_output);

		float orpullx = lib.nx(ORout[0], "") - 2;

		float orpully = lib.ny(ANDout[0], "") + 10;

		String[] ORPullUp = lib.CreateOrPullUp(orpullx, orpully, numOutputBits);

		lib.WireORtoPullUp(ORplane, ORPullUp);

		String[] ANDp = (String[]) ANDplane
				.elementAt(SchematicManager.ANDPLANE_pullup);

		float andpullx = lib.nx(ANDp[0], "") - 4;

		float andpully = lib.ny(ANDp[0], "") + 2;

		String[] ANDPullUp = lib.CreateAndPullUp(andpullx, andpully, numTerms);

		lib.WireANDtoPullUp(ANDplane, ANDPullUp);

		// lib.WriteLibrary(outputFileName);

	}

	public String text()

	{

		return lib.text();

	}

}